UNIT Convert;
{$v-}
INTERFACE

uses {mathe,} BitTools;

TYPE HexType = string[8];         { Hexzahl bis LongInt }
TYPE ExtHexzahl = string[20];        { Hexdarst. von Real bis Extended }
TYPE HexZiffer = String[2];
TYPE BinString = String[32];

TYPE PConvRec  = ^TConvRec;
     TConvRec  = Record
                  Case Integer Of
                   1 : (TBoolean: Boolean);
                   2 : (TByte: Byte);
                   3 : (TChar: Char);
                   4 : (TShortInt: ShortInt);
                   5 : (TInteger: Integer);
                   6 : (TWord: Word);
                   7 : (TLongInt: LongInt);
                   8 : (TReal: Real);
                   9 : (TString: ShortString);
                  10 : (TArray: Array [0..255] of Byte);
                 End;

TYPE TTypes  = (boolean_typ, byte_typ, char_typ, integer_typ, word_typ,
                ShortInt_typ, LongInt_Typ, real_typ, string_typ);

procedure ConvertTo (vTyp: TTypes; contents: String; var v);
function TypeXToStr (vTyp: TTypes; var v): string;
function BinStringToDez(XBin: BinString): LongInt;
function ByteToHex(var b): HexZiffer;
function IntegerToHex(h: Integer): HexType;
function WordToHex(w: Word): HexType;
function LongIntToHex(lngint: LongInt): HexType;
function HexForm(var rrr; size: integer) :ExtHexzahl;
function Nibble(hc: char): char;
function HexToByte(hex: Hexziffer): Byte;
function HexToShort(hex: Hexziffer): ShortInt;
function HexToShortInt(hex: Hexziffer): ShortInt; {wie HexToShort}
function HexToInteger(hex: HexType): Integer;
function HexToWord(hex: HexType): Word;
function HexToLongInt(Hex: HexType): LongInt;
function To_1aus16(w: word): Word;

IMPLEMENTATION

procedure ConvertTo (vTyp: TTypes; contents: String; var v);
var x: TConvRec absolute v;
    ii: integer;
    ev: integer;
    rr: real;
begin
   case vTyp of
     byte_typ    : begin
                      val (contents, ii, ev);
                      if ev=0 then X.TByte := Lo (ii);
                   end;
     char_typ    : X.TChar := contents [1];
     shortInt_typ: begin
                      val (contents, ii, ev);
                      if ev=0 then X.TShortInt := Lo (ii);
                   end;
     integer_typ : begin
                      val (contents, ii, ev);
                      if ev=0 then X.TInteger := ii;
                   end;
     word_typ    : begin
                      val (contents, rr, ev);
                      if ev=0 then X.TWord := Round (rr);
                   end;
     longint_typ : begin
                      val (contents, rr, ev);
                      if ev=0 then X.TLongInt := Round (rr);
                   end;
     real_typ    : begin
                      val (contents, rr, ev);
                      if ev=0 then X.TReal := rr;
                   end;
     string_typ  : X.TString := contents;
   end;
end;

function TypeXToStr (vTyp: TTypes; var v): string;
var x: TConvRec absolute v;
    st: string;
begin
   case vTyp of
     byte_typ    : begin Str (X.TByte, St); TypeXToStr := St; end;
     char_typ    : TypeXToStr := X.TChar;
     shortint_typ: begin Str (X.TShortInt, St); TypeXToStr := St; end;
     word_typ    : begin Str (X.TWord, St); TypeXToStr := St; end;
     integer_typ : begin Str (X.TInteger, St); TypeXToStr := St; end;
     longint_typ : begin Str (X.TLongInt, St); TypeXToStr := St; end;
     real_typ    : begin Str (X.TReal, St); TypeXToStr := St; end;
     string_typ  : TypeXToStr := X.TString;
   end;
end;

Function BinStringToDez(XBin: BinString): LongInt;
var dez: LongInt; m,n: byte; b: BinString absolute XBin;
Begin
   dez:=0;
   m:=byte(b[0])-1;
   for n:=1 to byte(b[0]) do
     begin
        If b[n]='1' Then setBit(dez,m);
        m:=pred(m);
     end;
   BinStringToDez:=dez;
End;

Function ByteToHex(var b): HexZiffer;
const hex: array[0..15] of char = '0123456789ABCDEF';
var bb: byte absolute b;
begin
   ByteToHex:=hex[bb shr 4] + hex[bb and 15];
end;

Function IntegerToHex(h: Integer): HexType;
var i, hb: byte; hs: HexType; hexa: HexZiffer;
Begin
   hs:='';
   For i:=1 to 2 do
     begin
        case i of
          1: begin hb:=h shr 8; hexa:=ByteToHex(hb); end;
          2: begin hb:=h mod 256; hexa:=ByteToHex(hb); end;
        end;
        hs:=Concat(hs,hexa);
     end;
   IntegerToHex:=hs;
End;

Function WordToHex(w: Word): HexType;
var i, hb: byte; hs: HexType; hexa: HexZiffer;
Begin
   hs:='';
   For i:=1 to 2 do
     begin
        case i of
          1: begin hb:=w shr 8; hexa:=ByteToHex(hb); end;
          2: begin hb:=w mod 256; hexa:=ByteToHex(hb); end;
        end;
        hs:=Concat(hs,hexa);
     end;
   WordToHex := hs;
End;

function LongIntToHex(lngint: LongInt): HexType;
var LngIntZ: array [0..1] of word absolute lngint; i: integer;
    Hexwert: HexType;
begin
   HexWert := '';
   for i:=1 downto 0 do
       Hexwert := Hexwert + IntegerToHex (lngintz [i]);
   LongIntToHex := Hexwert;
end;

Function HexForm(var rrr; size: integer) :ExtHexzahl;
var Z:Array[0..9] of byte absolute rrr;
    ix:byte; hex:hexziffer; Shex:ExtHexzahl;
Begin
   Shex:='';
   For ix:=0 to pred (size) do
     Begin
        hex:=ByteToHex(Z[ix]);
        Shex:=Concat(Shex,hex);
     End;
   HexForm:=Shex;
End;

Function Nibble(hc: char): char;
Begin
   nibble:=chr(255);
   Case hc Of
    '0'..'9': nibble:=chr(ord(hc)-$30);
    'A'..'F': nibble:=chr(ord(hc)-$37);
    'a'..'f': begin hc:=UpCase(hc); nibble:=chr(ord(hc)-$37); end;
   End;
End;

Function HexToByte(hex: Hexziffer): Byte;
var p,i,l: byte; conv: byte;
Begin
   conv:=0; p:=0;
   l:=byte(hex[0]);
   for i:=l downto 1 do
     begin
        conv:=conv + ord(Nibble(Hex[i])) shl (p*4);
        p:=succ(p);
     end;
   HexToByte:=conv;
End;

Function HexToShort(hex: Hexziffer): ShortInt;
Var short: ShortInt;
    sByte: Byte;
Begin
   sByte := HexToByte(hex);
   move(sByte, short, 1);
   HexToShort := short;
End;

Function HexToShortInt(hex: Hexziffer): ShortInt;
Begin
   HexToShortInt := HexToShort(hex);
End;

Function HexToInteger(hex: HexType): Integer;
var p,i,l: byte; conv: Integer;
Begin
   conv:=0; p:=0;
   l:=byte(hex[0]);
   for i:=l downto 1 do
     begin
        conv:=conv + ord(Nibble(Hex[i])) shl (p*4);
        p:=succ(p);
     end;
   HexToInteger:=conv;
End;

Function HexToWord(hex: HexType): Word;
Begin
   HexToWord := HexToInteger (hex);
End;

Function HexToLongInt(Hex: HexType): LongInt;

var VTmp   : LongInt;
    ATmp   : array[0..1] of Integer;
    XRes   : LongInt absolute ATmp;
    LoWord,
    HiWord : HexType;
    Len    : Integer;
Begin
   VTmp := 0;
   Len := Byte (Hex [0]);
   fillchar (ATmp, SizeOf (ATmp), 0);
   If Len > 4 Then
      begin
         LoWord := copy (Hex, 1+(Len-4), 4);
         HiWord := copy (Hex, 1, (Len - 4));
         VTmp := HexToInteger (HiWord);
         ATmp [1] := VTmp;
         VTmp := HexToInteger (LoWord);
         ATmp [0] := VTmp;
         HexToLongInt := XRes;
      end
   else HexToLongInt := HexToWord (Hex);
End;

Function To_1aus16(w: word): Word;
var c: integer;
Begin
   c:=0;
   setBit(c,w);
   To_1aus16:=c;
End;

END.
