unit canvas;
{
 .#include "kernel.h"
 .#include "widget.h"
 .#include "canvas.h"
}
interface

uses guitypes, widget;

{$i cdefs.inc}

{$ifdef LINK_CLIBS}
  {$LINK widget.o}
{$endif}


type
  PCanvas = ^TCanvas;
  TCanvas = record
	o: TWidget;
  end;


var
  AppVersion: l_ulong;

const
  AppName: l_text   = 'Canvas widget';
  nUID   : l_text   = 'canvas';
  NeededLibs: l_uid = ( 'widget', '' );


procedure  CDraw(o: PWidget; buffer: p_bitmap; w: PRect ); {$ifdef LINK_CLIBS}external;{$endif}
function  CEventHandler(o: PWidget; Ev: PEvent ): l_bool; {$ifdef LINK_CLIBS}external;{$endif}
function  CreateCanvas(App: PApplication; r: TRect): PCanvas; {$ifdef LINK_CLIBS}external;{$endif}

implementation
{$ifndef LINK_CLIBS}

(**
*	NAME: CDraw
*	DESCRIPTION: The standard drawing function
*)
procedure  CDraw(o: PWidget; buffer: p_bitmap; w: PRect );
begin
	rectfill(buffer, o^.Absolute.a.x, o^.Absolute.a.y, o^.Absolute.b.x, o^.Absolute.b.y, o^.BackgroundColor);
end;

(**
*	NAME: CEventHandler
*	DESCRIPTION: The standard event handler
*)
function  CEventHandler(o: PWidget; Ev: PEvent ): l_bool;
begin
	CEventHandler := false;
end;

(**
*	NAME: CreateCanvas
*	DESCRIPTION: Creates a new canvas widget
*)
function  CreateCanvas(App: PApplication; r: TRect): PCanvas;
var c: PCanvas;
begin
	New(c);

	if assigned(c) then CreateCanvas := NIL;

	fillchar(c, sizeof(TCanvas), 0);

	IntialiseWidget(App, StdWidgetClass, PWIDGET(c), r );

	PWIDGET(c)^.Draw := {ifdef fpc}@{$endif}CDraw;
	PWIDGET(c)^.EventHandler := {ifdef fpc}@{$endif}CEventHandler;

	CreateCanvas := c;
end;

function LibMain ( argc: integer; argv: l_text ): l_bool;
begin
  { APPEXPORT(CreateCanvas); }

	LibMain := true;
end;

procedure Close;
begin

end;

{$ifdef OPascal}
initialization
{$else}
begin
{$endif}
   AppVersion := ULONG_ID(0,8,0,0);

{$endif}  {$LINK_CLIBS}
end.
