unit checkbox;
{
 .#include "kernel.h"
 .#include "widget.h"
 .#include "checkbox.h"
 .#include "string.h"
}
interface

uses guitypes,dynld,events,text,metrics,skin,widget,font,allegro;

{$i cdefs.inc}

{$ifdef LINK_CLIBS}
   {$LINK widget.o}
   {$LINK skin.o}
{$ENDIF}

var
 AppVersion: l_ulong;
 
const
  AppName: l_text = 'Checkbox Widget';
  nUID   : l_text = 'checkbox';
  NeededLibs: array[0..2] of string = ( 'widget', 'skin', '' );

const
  CheckboxCleared: PSkin = NIL;
  CheckboxChecked: PSkin = NIL;


type 
 PCheckbox = ^TCheckbox;
 TCheckbox = record
	o      : TWidget;

	Checked: l_bool;
	Caption: l_text;
 end;

function CreateCheckbox(App: PApplication; r: TRect; Caption: l_text): PCheckBox;

{define CHECKBOX(o)	((PCheckbox)(o))}

implementation
{$ifndef LINK_CLIBS}

var
  CheckboxClass: PWidgetClass;

procedure CheckboxDraw ( o:PWidget; buffer:p_bitmap; w:PRect );
begin
        if ( UseSkins ) then
        begin
                if not(PCHECKBOX(o)^.Checked) then
                        DrawSkin(buffer, CheckboxCleared, o^.Absolute.a.x, o^.Absolute.a.y , o^.Absolute.b.x, o^.Absolute.b.y)
                else
                        DrawSkin(buffer, CheckboxChecked, o^.Absolute.a.x, o^.Absolute.a.y , o^.Absolute.b.x, o^.Absolute.b.y);

                al_textout_ex(buffer,
                   default_font,
                   PCHECKBOX(o)^.Caption,
                   o^.Absolute.a.x + CheckboxChecked^.Left + 1,
                   o^.Absolute.a.y + (
                   o^.Absolute.b.y-o^.Absolute.a.y) div 2 - al_text_height(CheckboxCleared^.Font) div 2,
                   CheckboxCleared^.FontColor,-1
                );
        end else begin

                al_rectfill(buffer,w^.a.x,w^.a.y,w^.b.x,w^.b.y,COL_3DFACE);

                al_rect(buffer,
                  o^.Absolute.a.x+1,
                  (o^.Absolute.b.y+o^.Absolute.a.y) div 2-5,
                  o^.Absolute.a.x+11,
                  (o^.Absolute.b.y+o^.Absolute.a.y) div 2+5,
                  COL_3DTEXT
                  );

                if ( PCHECKBOX(o)^.Checked ) then
                  al_rectfill(buffer,
                    o^.Absolute.a.x+3,
                    (o^.Absolute.a.y+o^.Absolute.b.y) div 2-3,
                    o^.Absolute.a.x+9,
                    (o^.Absolute.a.y+o^.Absolute.b.y) div 2+3,
                    COL_3DTEXT
                  );

                al_textout_ex(
                  buffer,
                  default_font,
                  PCHECKBOX(o)^.Caption,
                  o^.Absolute.a.x + 15,
                  (o^.Absolute.b.y+o^.Absolute.a.y) div 2 - al_text_height(default_font) div 2,
                  COL_3DTEXT,-1
                );
        end;
end;

function CheckboxEventHandler ( o: PWidget; Ev: PEvent ): l_bool;
begin
        CheckboxEventHandler := false;
        if (Ev^.aType = EV_MOUSE) then
        begin
                if (Ev^.Message = WEvMouseLDown) then
                begin
                        PCHECKBOX(o)^.Checked := not PCHECKBOX(o)^.Checked;
                        WidgetDraw(o, NIL);
                        CheckboxEventHandler := true;
                end;

                (*if (Ev^.Message = WEvMouseLUp) then
                begin
                        PCHECKBOX(o)^.Checked := not PCHECKBOX(o)^.Checked;
                        WidgetDraw(o, NIL);
                        CheckboxEventHandler := true;
                end;*)

        end;
end;

function dim(c: l_bool; v1,v2: l_ulong): l_ulong;
begin
  if c then dim := v1 else dim := v2;
end;

function CreateCheckbox(App:PApplication; r:TRect; Caption:l_text): PCheckbox;
var
  b: PCheckBox;
begin
        New(b);

        if not assigned(b) then CreateCheckBox := NIL else
        begin
        fillchar(b^, sizeof(TCheckbox), 0);

        b^.Checked := false;
        b^.Caption := Caption;

        (**
        *       Set the width and height to checkbox skin item
        *               width and height.
        *)
        if ( UseSkins ) then begin
           r.b.x := r.a.x
           (**
           +dim(
              CheckboxCleared^.Left+CheckboxCleared^.Right+1+al_text_length(CheckboxCleared^.Font, b^.Caption)>CheckboxCleared^.Skin^.w,
              CheckboxCleared^.Left + CheckboxCleared^.Right + 1 + al_text_length(CheckboxCleared^.Font, b^.Caption),
              CheckboxCleared^.Skin^.w
            );
            **);
           r.b.y := r.a.y+
           dim(
              CheckboxCleared^.Skin^.h>al_text_height(CheckboxCleared^.Font),
              CheckboxCleared^.Skin^.h,al_text_height(CheckboxCleared^.Font)
           );
        end;

        IntialiseWidget(App, CheckboxClass, PWIDGET(b), r );

        PWIDGET(b)^.Draw := {$ifdef fpc}@{$endif}CheckboxDraw;
        PWIDGET(b)^.EventHandler := {$ifdef fpc}@{$endif}CheckboxEventHandler;

        CreateCheckBox := b;
        end;
end;

function CheckBoxSetRProp ( o:PWidget; Name:l_text; const Value; Redraw:l_bool ): l_bool;
begin
        if ( TextCompare(Name,'caption') = 0 ) then begin
                if ( PCHECKBOX(o)^.Caption <> '' ) then PCHECKBOX(o)^.Caption := '';
                PCHECKBOX(o)^.Caption := l_text(Value);
                if ( Redraw ) then WidgetDraw(PWIDGET(o), NIL);
                CheckBoxSetRProp := true;
        end else
        if ( TextCompare(Name,'checked') = 0 ) then begin
                PCHECKBOX(o)^.Checked := l_bool(Value);
                if ( Redraw ) then WidgetDraw(PWIDGET(o), NIL);
                CheckBoxSetRProp := true;
        end
        else
        CheckBoxSetRProp := false;
end;

function CheckBoxGetRProp (o:PWidget; Name:l_text): Pointer;
begin
   if ( TextCompare(Name,'caption') = 0 ) then CheckBoxGetRProp := @PCHECKBOX(o)^.Caption else
   if ( TextCompare(Name,'checked') = 0 ) then CheckBoxGetRProp := DuplicateBool(PCHECKBOX(o)^.Checked) else
        CheckBoxGetRProp := NIL;
end;

function StdCreateCheckbox ( App:PApplication; r:TRect ): PWidget;
begin
    StdCreateCheckbox := PWIDGET(CreateCheckbox( App, r, ''));
end;

function LibMain ( argc: integer; argv:l_text ): l_bool;
var r: TRect; p: PCheckBox;
begin
        CheckboxClass := CreateWidgetClass( ULONG_ID('C','h','k','B'), StdWidgetClass, 0 );
        CheckboxClass^.StdCreate := {$ifdef fpc}@{$endif}StdCreateCheckbox;
        CheckboxClass^.SetRProp := {$ifdef fpc}@{$endif}CheckBoxSetRProp;
        CheckboxClass^.GetRProp := {$ifdef fpc}@{$endif}CheckBoxGetRProp;

        WClassRegisterProp(CheckboxClass,PTYPE_STRING,'caption');
        WClassRegisterProp(CheckboxClass,PTYPE_BOOL,'checked');


        CheckboxCleared := GetSkinItem('CheckboxCleared');
        CheckboxChecked := GetSkinItem('CheckboxChecked');
        (*
        APPEXPORT(CreateCheckbox);
        SYSEXPORT(CreateCheckbox);
        *)
        (*;
        RectAssign(r, 50,50,150,70);
        p := CreateCheckbox(Me, r, 'Bujaka');
        InsertWidget(PWIDGET(DeskTop), PWIDGET(p));
        WidgetDraw(PWIDGET(p), NIL);*)

        LibMain := true;
end;

procedure Close;
begin

end;

{$ifdef OPascal}
initialization
{$else}
begin
{$endif}
  AppVersion := ULONG_ID(0,0,0,1);

{$endif} {LINK_CLIBS}
end.
