////////////////////////////////////////////////////////////////////////////////
//
//  Clipboard - Header File
//
//	(c) Copyright 2003,2004 Point Mad, Lukas Lipka. All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

unit clipbrd;

interface

uses ctypes,guitypes,dms;


{$i cdefs.inc}

{$IFDEF LINK_CLIBS}
  {$LINK clipboard.o}
{$ENDIF}

type
  TGetDataProc = procedure(var Arg: Pointer; Mode: u_long);
 
  PClipboardItem = ^TClipboardItem;
  TClipboardItem = packed record
	
	ClpType: l_ulong;
	Data: Pointer;
	
	GetData: TGetDataProc;
	
  end;
	

procedure ClipboardFree;  {$IFDEF LINK_CLIBS}external;{$ENDIF}
function  ClipboardGet ( ClpType: l_ulong ): Pointer;   {$IFDEF LINK_CLIBS}external;{$ENDIF}
procedure ClipboardPut ( ClpType: l_ulong; const Data: Pointer; Duplicate: l_bool );   {$IFDEF LINK_CLIBS}external;{$ENDIF}


implementation

{$IFNDEF LINK_CLIBS}

const
     AppName   : l_text  = 'Clipboard';
     nUID      : l_text  = 'clipbrd';

var
 Clipboard: TClipboardItem;
 AppVersion: l_ulong;

procedure ClipboardPut ( ClpType: l_ulong; const Data: Pointer; Duplicate: l_bool );
begin
	if ( Duplicate ) then
	    Clipboard.Data := DuplicateData2(ClpType, Data)
	else begin
	    Clipboard.Data := Data;
            Clipboard.ClpType := ClpType;
        end;
end;

function ClipboardGet ( ClpType: l_ulong ) : Pointer;
begin
	if ( Clipboard.ClpType <> ClpType ) then ClipboardGet := nil;
	ClipboardGet := Clipboard.Data;
end;

procedure ClipboardFree;
begin
	if Assigned( Clipboard.Data ) then FreeData2(Clipboard.ClpType, Clipboard.Data);
	Clipboard.ClpType := 0;
end;

{
l_int LibMain( int argc, l_text *argv )

	
	APPEXPORT(ClipboardPut);
	APPEXPORT(ClipboardGet);
	APPEXPORT(ClipboardFree);

	return true;
}

procedure Close();
begin	
	ClipboardFree();	
end;

{$ifdef OPascal}
initialization
{$else}
begin
{$endif}
   AppVersion := ULONG_ID(0, 0, 0, 1);

{$ENDIF}
end.
