(*////////////////////////////////////////////////////////////////////////////////*)
(*//                                                                              *)
(*//  Color selector                                                              *)
(*//                                                                              *)
(*//  (c) Copyright 2004 Point Mad. All rights reserved.                          *)
(*//                                                                              *)
(*////////////////////////////////////////////////////////////////////////////////*)
unit colsel;
(*
  #include "kernel.h"
  #include "colsel.h"
  #include "window.h"
  #include "button.h"
  #include "tabbook.h"
  #include"widget.h"
  #include "label.h"
  #include "textbox.h"
  #include "window.h"
  #include "listview.h"
*)

interface

uses
  guitypes,dynld,dms,events,text,list,grfx,metrics,widget,window,textbox,ulabel,
  listview,mousedrv,allegro,registry,keyboard,tabbook,button,skin,scrllbar;

{$i cdefs.inc}

{$ifdef LINK_CLIBS}
 {$LINK kernel.o}
 {$LINK colsel.o}
 {$LINK window.o}
 {$LINK button.o}
 {$LINK tabbook.o}
 {$LINK widget.o}
 {$LINK label.o}
 {$LINK textbox.o}
 {$LINK window.o}
 {$LINK listview.o}
{$endif}

type
  PColSelEl = ^TColSelEl;

  PColSelDat = ^TColSelDat;
  TColSelDat = record

	hue,sallgh,
    sr,sg,sb,
    pal       : PColSelEl;
	tr,tg,tb,
    th,ts,tv,
    thtml,tfav: PTextbox;
	w         : PWindow;
	col       : PWidget;
	l         : PLabel;
	lv        : PListview;
	
	r, g, b   : Integer;
	h,s,v     : Single;
	
  end;

  TColSelEl = record

	o: TWidget;

	a: PColSelDat;
	
  end;

  PColFavItem = ^TColFavItem;
  TColFavItem = record

	o:	TListviewItem;

	r, g, b: integer;

  end;

function DialogColor ( var rgb: AL_RGB; var col: l_color ): l_bool; {$ifdef LINK_CLIBS}external;{$endif}

implementation
{$ifndef LINK_CLIBS}
{$ifdef OPascal}
uses Sysutils;
{$else}
uses OSysutil;
{$endif}
(*////////////////////////////////////////////////////////////////////////////////*)
var
  AppVersion: l_ulong;

const
  AppName: l_text = 'Color Selector';
  nUID   : l_text = 'colsel';
  NeededLibs: array[0..5] of l_text = ( 'widget','window','button','tabbook','label','' );

  Palette: array[0..5,0..7] of AL_RGB = (
   ((r:255;g:0;b:0),(r:64;g:0;b:0),(r:128;g:0;b:0),(r:192;g:0;b:0),(r:255;g:64;b:64),(r:255;g:128;b:128), (r:255;g:192;b:192),(r:0;g:0;b:0)),
   ((r:255;g:255;b:0),	(r:64;g:64;b:0),(r:128;g:128;b:0),(r:192;g:192;b:0),(r:255;g:255;b:64),	(r:255;g:255;b:128), (r:255;g:255;b:192), (r:32;g:32;b:32)	),
   ((r:0;g:255;b:0),	(r:0;g:64;b:0),	(r:0;g:128;b:0),  (r:0;g:192;b:0),  (r:64;g:255;b:64),	(r:128;g:255;b:128), (r:192;g:255;b:192), (r:64;g:64;b:64)	),
   ((r:0;g:255;b:255),	(r:0;g:64;b:64),(r:0;g:128;b:128),(r:0;g:192;b:192),(r:64;g:255;b:255),	(r:128;g:255;b:255), (r:192;g:255;b:255), (r:128;g:128;b:128)	),
   ((r:0;g:0;b:255),	(r:0;g:0;b:64),	(r:0;g:0;b:128),  (r:0;g:0;b:192),  (r:64;g:64;b:255),	(r:128;g:128;b:255), (r:192;g:192;b:255), (r:192;g:192;b:192)	),
   ((r:255;g:0;b:255),	(r:64;g:0;b:64),(r:128;g:0;b:128),(r:192;g:0;b:192),(r:255;g:64;b:255),	(r:255;g:128;b:255), (r:255;g:192;b:255), (r:255;g:255;b:255)	)
  );
(*////////////////////////////////////////////////////////////////////////////////*)
function ColFavAddItem ( o:PListview; name: l_text; r, g, b: Integer ): PColFavItem;
var
  p: PColFavItem; img: PImage;
begin
	
	New(p);
	if not assigned(p) then ColFavAddItem := NIL else
	begin
 	  fillchar(p^, sizeof(TColFavItem), 0);

	  ListviewInitItem(PLISTVIEWITEM(p),name,NIL);
	
	  img := al_create_bitmap(16,16);
	  al_rectfill(img,0,0,15,15,makecol(r,g,b));
	  PLISTVIEWITEM(p)^.Icon := NewIcon(img,nil,nil);
	
	  p^.r := r;
	  p^.g := g;
	  p^.b := b;
	
	ListAdd (PLISTVIEW(o)^.Items, name, p, {$ifdef fpc}@{$endif}FreeListviewItem);
	ColFavAddItem := p;
	end;
end;

(*////////////////////////////////////////////////////////////////////////////////*)
procedure RDraw ( o:PWidget; buffer:p_bitmap; w:PRect );
var x: integer;
begin	
    x:=0;
	while ( x <= o^.Absolute.b.x-o^.Absolute.a.x ) do begin
		al_vline(buffer,o^.Absolute.a.x+x,o^.Absolute.a.y,
            o^.Absolute.b.y,makecol(255*x div (o^.Absolute.b.x-o^.Absolute.a.x),0,0));
		inc(x);	
	end;
	x := PCOLSELEL(o)^.a^.r*(o^.Absolute.b.x-o^.Absolute.a.x) div 255;
	al_rect(buffer,o^.Absolute.a.x+x-1,o^.Absolute.a.y,o^.Absolute.a.x+x+1,o^.Absolute.b.y,makecol(255,255,255));
end;
(*////////////////////////////////////////////////////////////////////////////////*)
procedure GDraw ( o:PWidget; buffer:p_bitmap; w:PRect );
var x: integer;
begin
	x := 0;
	while ( x <= o^.Absolute.b.x-o^.Absolute.a.x ) do begin
		al_vline(buffer,o^.Absolute.a.x+x,o^.Absolute.a.y,
            o^.Absolute.b.y,makecol(0,255*x div (o^.Absolute.b.x-o^.Absolute.a.x),0));
		inc(x);	
	end;
	x := PCOLSELEL(o)^.a^.g*(o^.Absolute.b.x-o^.Absolute.a.x) div 255;
	al_rect(buffer,o^.Absolute.a.x+x-1,o^.Absolute.a.y,
        o^.Absolute.a.x+x+1,o^.Absolute.b.y,makecol(255,255,255));
end;
(*////////////////////////////////////////////////////////////////////////////////*)
procedure BDraw ( o:PWidget; buffer:p_bitmap; w:PRect );
var x: integer;
begin
	x:=0;
	while ( x <= o^.Absolute.b.x-o^.Absolute.a.x ) do begin
		al_vline(buffer,o^.Absolute.a.x+x,o^.Absolute.a.y,
            o^.Absolute.b.y,makecol(0,0,255*x div (o^.Absolute.b.x-o^.Absolute.a.x)));
		inc(x);	
	end;
	x := PCOLSELEL(o)^.a^.b*(o^.Absolute.b.x-o^.Absolute.a.x) div 255;
	al_rect(buffer,o^.Absolute.a.x+x-1,o^.Absolute.a.y,
       o^.Absolute.a.x+x+1,o^.Absolute.b.y,makecol(255,255,255));
end;
(*////////////////////////////////////////////////////////////////////////////////*)
procedure HueSelDraw ( o:PWidget; buffer:p_bitmap; w:PRect );
var r,g,b,x: integer;
begin
	x:=0;
	while ( x <= o^.Absolute.b.x-o^.Absolute.a.x ) do begin
		al_hsv_to_rgb(360*x div (o^.Absolute.b.x-o^.Absolute.a.x),1,1,r,g,b);
		al_vline(buffer,o^.Absolute.a.x+x,o^.Absolute.a.y,o^.Absolute.b.y,makecol(r,g,b));
		inc(x);	
	end;
	x := Round(PCOLSELEL(o)^.a^.h*(o^.Absolute.b.x-o^.Absolute.a.x)) div 360;
	al_rect(buffer,o^.Absolute.a.x+x-1,o^.Absolute.a.y,o^.Absolute.a.x+x+1,o^.Absolute.b.y,makecol(0,0,0));
end;
(*////////////////////////////////////////////////////////////////////////////////*)
procedure SalLghSelDraw ( o:PWidget; buffer:p_bitmap; w:PRect );
var r,g,b,x,y: integer;
begin
        x:=0; y:=0;
	while ( x <= o^.Absolute.b.x-o^.Absolute.a.x ) do begin
		y:=0;
		while ( y <= o^.Absolute.b.y-o^.Absolute.a.y ) do begin
			al_hsv_to_rgb(PCOLSELEL(o)^.a^.h,
			(Single(x))/(Single((o^.Absolute.b.x-o^.Absolute.a.x))),
			(Single(y))/(Single((o^.Absolute.b.y-o^.Absolute.a.y))),
			r,g,b);
			al_putpixel(buffer,o^.Absolute.a.x+x,o^.Absolute.a.y+y,makecol(r,g,b));
			inc(y);	
		end;
		inc(x);	
	end;
	x := Round(PCOLSELEL(o)^.a^.s*(o^.Absolute.b.x-o^.Absolute.a.x));
	y := Round(PCOLSELEL(o)^.a^.v*(o^.Absolute.b.y-o^.Absolute.a.y));
	al_putpixel(buffer,o^.Absolute.a.x+x,o^.Absolute.a.y+y,makecol(255,255,255));
	al_rect(buffer,o^.Absolute.a.x+x-2,o^.Absolute.a.y+y-2,o^.Absolute.a.x+x+2,o^.Absolute.a.y+y+2,makecol(0,0,0));
	al_rect(buffer,o^.Absolute.a.x+x-3,o^.Absolute.a.y+y-3,o^.Absolute.a.x+x+3,o^.Absolute.a.y+y+3,makecol(255,255,255));
end;
(*////////////////////////////////////////////////////////////////////////////////*)
procedure PaletteSelDraw ( o:PWidget; buffer:p_bitmap; w:PRect );
var x,y: integer;
begin
	x := 0;
	while ( x < 8 ) do begin
		y := 0;
		while ( y < 6 ) do
		begin	
			al_rectfill(buffer,
			o^.Absolute.a.x+(x*10),
			o^.Absolute.a.y+(y*10),
			o^.Absolute.a.x+(x*10)+10,
			o^.Absolute.a.y+(y*10)+10,
			makecol(Palette[y][x].r,Palette[y][x].g,Palette[y][x].b));

			inc(y);	
		end; 
		
		inc(x);	
	end;
end;
(*////////////////////////////////////////////////////////////////////////////////*)
procedure UpdateColor ( a: PColSelDat );
begin	
	a^.col^.BackgroundColor := makecol(a^.r,a^.g,a^.b);
	LabelSetText(a^.l,'r:%d g:%d b:%d\nh:%.0f s:%1.3f v:%1.3f',[a^.r,a^.g,a^.b,a^.h,a^.s,a^.v]);
	TextBoxSetText(a^.th,'%.0f',[a^.h]);
	TextBoxSetText(a^.ts,'%1.3f',[a^.s]);
	TextBoxSetText(a^.tv,'%1.3f',[a^.v]);
	
	TextBoxSetText(a^.tr,'%d',[a^.r]);
	TextBoxSetText(a^.tg,'%d',[a^.g]);
	TextBoxSetText(a^.tb,'%d',[a^.b]);

	TextBoxSetText(a^.thtml,'#%02x%02x%02x',[a^.r,a^.g,a^.b]);

	WidgetDraw(PWIDGET(a^.hue), NIL);
	WidgetDraw(PWIDGET(a^.sallgh), NIL);
	WidgetDraw(PWIDGET(a^.col), NIL);
	WidgetDraw(PWIDGET(a^.sr), NIL);
	WidgetDraw(PWIDGET(a^.sg), NIL);
	WidgetDraw(PWIDGET(a^.sb), NIL);

end;
(*////////////////////////////////////////////////////////////////////////////////*)
function REventHandler ( o: PWidget; Ev: PEvent ): l_bool;
begin
	if (Ev^.aType = EV_MOUSE) then begin
		if (Ev^.Message = WEvMouseLDown) or ((Ev^.Message = WEvMouseMove) and ((Mouse^.State.b and BUTTON_LEFT)=BUTTON_LEFT)) then
		begin
			PCOLSELEL(o)^.a^.r := (Mouse^.State.p.x-o^.Absolute.a.x)*255 div (o^.Absolute.b.x-o^.Absolute.a.x);
			al_rgb_to_hsv(PCOLSELEL(o)^.a^.r,PCOLSELEL(o)^.a^.g,PCOLSELEL(o)^.a^.b,PCOLSELEL(o)^.a^.h,PCOLSELEL(o)^.a^.s,PCOLSELEL(o)^.a^.v);
			UpdateColor(PCOLSELEL(o)^.a);
			REventHandler := true;
		end;
	end else REventHandler := false;
end;
(*////////////////////////////////////////////////////////////////////////////////*)
function GEventHandler ( o:PWidget; Ev:PEvent ): l_bool;
begin
	if (Ev^.aType = EV_MOUSE) then begin
		if (Ev^.Message = WEvMouseLDown) or ((Ev^.Message = WEvMouseMove) and ((Mouse^.State.b and BUTTON_LEFT)=BUTTON_LEFT)) then
		begin
			PCOLSELEL(o)^.a^.g := (Mouse^.State.p.x-o^.Absolute.a.x)*255 div (o^.Absolute.b.x-o^.Absolute.a.x);
			al_rgb_to_hsv(
              PCOLSELEL(o)^.a^.r,
              PCOLSELEL(o)^.a^.g,
              PCOLSELEL(o)^.a^.b,
              PCOLSELEL(o)^.a^.h,
              PCOLSELEL(o)^.a^.s,
              PCOLSELEL(o)^.a^.v
            );
			UpdateColor(PCOLSELEL(o)^.a);
			GEventHandler := true;
		end;
	end else GEventHandler := false;
end;
(*////////////////////////////////////////////////////////////////////////////////*)
function BEventHandler ( o: PWidget; Ev: PEvent ): l_bool;
begin
    BEventHandler := false;
	if (Ev^.aType = EV_MOUSE) then begin
		if (Ev^.Message = WEvMouseLDown) or ((Ev^.Message = WEvMouseMove) and ((Mouse^.State.b and BUTTON_LEFT)=BUTTON_LEFT)) then
		begin
			PCOLSELEL(o)^.a^.b := (Mouse^.State.p.x-o^.Absolute.a.x)*255 div (o^.Absolute.b.x-o^.Absolute.a.x);
			al_rgb_to_hsv(PCOLSELEL(o)^.a^.r,PCOLSELEL(o)^.a^.g,PCOLSELEL(o)^.a^.b,PCOLSELEL(o)^.a^.h,PCOLSELEL(o)^.a^.s,PCOLSELEL(o)^.a^.v);
			UpdateColor(PCOLSELEL(o)^.a);
			BEventHandler := true;
		end;
	end else BEventHandler := false;
end;
(*////////////////////////////////////////////////////////////////////////////////*)
function HueSelEventHandler ( o: PWidget; Ev: PEvent ): l_bool;
begin	
    if (Ev^.aType = EV_MOUSE) then begin
		if (Ev^.Message = WEvMouseLDown) or ((Ev^.Message = WEvMouseMove) and ((Mouse^.State.b and BUTTON_LEFT)=BUTTON_LEFT)) then
        begin
			PCOLSELEL(o)^.a^.h := (Mouse^.State.p.x-o^.Absolute.a.x)*360 div (o^.Absolute.b.x-o^.Absolute.a.x);
			al_hsv_to_rgb(PCOLSELEL(o)^.a^.h,PCOLSELEL(o)^.a^.s,PCOLSELEL(o)^.a^.v,PCOLSELEL(o)^.a^.r,PCOLSELEL(o)^.a^.g,PCOLSELEL(o)^.a^.b);
			UpdateColor(PCOLSELEL(o)^.a);
			HueSelEventHandler := true;
		end;
	end else HueSelEventHandler := false;
end;
(*////////////////////////////////////////////////////////////////////////////////*)
function SalLghSelEventHandler ( o: PWidget; Ev: PEvent ): l_bool;
begin
	if (Ev^.aType = EV_MOUSE) then begin
		if (Ev^.Message = WEvMouseLDown) or ((Ev^.Message = WEvMouseMove) and ((Mouse^.State.b and BUTTON_LEFT)=BUTTON_LEFT)) then
		begin
			PCOLSELEL(o)^.a^.s := Single((Mouse^.State.p.x-o^.Absolute.a.x))/Single((o^.Absolute.b.x-o^.Absolute.a.x));
			PCOLSELEL(o)^.a^.v := Single((Mouse^.State.p.y-o^.Absolute.a.y))/Single((o^.Absolute.b.y-o^.Absolute.a.y));
			al_hsv_to_rgb(PCOLSELEL(o)^.a^.h,PCOLSELEL(o)^.a^.s,PCOLSELEL(o)^.a^.v,PCOLSELEL(o)^.a^.r,PCOLSELEL(o)^.a^.g,PCOLSELEL(o)^.a^.b);
			UpdateColor(PCOLSELEL(o)^.a);
			SalLghSelEventHandler := true;
		end;
	end else SalLghSelEventHandler := false;
end;
(*////////////////////////////////////////////////////////////////////////////////*)
function PaletteSelEventHandler ( o: PWidget; Ev: PEvent ): l_bool;
var x,y: integer;
begin
	if (Ev^.aType = EV_MOUSE) then begin
		if (Ev^.Message = WEvMouseLDown) or ((Ev^.Message = WEvMouseMove) and ((Mouse^.State.b and BUTTON_LEFT)=BUTTON_LEFT)) then begin
			x:=(Mouse^.State.p.x-o^.Absolute.a.x) div 10;
			y:=(Mouse^.State.p.y-o^.Absolute.a.y) div 10;
			
			PCOLSELEL(o)^.a^.r := Palette[y][x].r;
			PCOLSELEL(o)^.a^.g := Palette[y][x].g;
			PCOLSELEL(o)^.a^.b := Palette[y][x].b;
			al_rgb_to_hsv(PCOLSELEL(o)^.a^.r,PCOLSELEL(o)^.a^.g,PCOLSELEL(o)^.a^.b,PCOLSELEL(o)^.a^.h,PCOLSELEL(o)^.a^.s,PCOLSELEL(o)^.a^.v);
			
			UpdateColor(PCOLSELEL(o)^.a);
			PaletteSelEventHandler := true;
		end;
	end else PaletteSelEventHandler := false;
end;
(*////////////////////////////////////////////////////////////////////////////////*)
function CreateHueSel ( App: PApplication; r: TRect; a: PColSelDat ): PColSelEl;
var o: PColSelEl;
begin
	New(o);
	if not assigned(o) then CreateHueSel := NIL else begin
	fillchar(o^,sizeof(TColSelEl),0);
	IntialiseWidget(App, StdWidgetClass, PWIDGET(o), r);
	PWIDGET(o)^.Draw := {$ifdef fpc}@{$endif}HueSelDraw;
	PWIDGET(o)^.EventHandler := {$ifdef fpc}@{$endif}HueSelEventHandler;
	o^.a := a;
	PWIDGET(o)^.Flags := PWIDGET(o)^.Flags or WFForceBuffer;
	CreateHueSel := o;
	end;
end;
(*////////////////////////////////////////////////////////////////////////////////*)
function CreateSalLghSel ( App: PApplication; r: TRect; a: PColSelDat ): PColSelEl;
var o: PColSelEl;
begin	
    New(o);
	if not assigned(o) then CreateSalLghSel := NIL else
	begin
	fillchar(o, sizeof(TColSelEl), 0);
	IntialiseWidget(App, StdWidgetClass, PWIDGET(o), r);
	PWIDGET(o)^.Draw := {$ifdef fpc}@{$endif}SalLghSelDraw;
	PWIDGET(o)^.EventHandler := {$ifdef fpc}@{$endif}SalLghSelEventHandler;
	o^.a := a;
	PWIDGET(o)^.Flags := PWIDGET(o)^.Flags or WFForceBuffer;
	CreateSalLghSel := o;
	end;
end;
(*////////////////////////////////////////////////////////////////////////////////*)
function CreateRGBSel ( App:PApplication; r:TRect; a:PColSelDat; id:l_ulong ): PColSelEl;
var o: PColSelEl;
begin
	New(o);
	if not assigned(o) then CreateRGBSel := NIL else
	begin
	fillchar(o^, sizeof(TColSelEl), 0);
	IntialiseWidget(App, StdWidgetClass, PWIDGET(o), r);
	
	
	case id of
        1 : begin
  			PWIDGET(o)^.Draw := {$ifdef fpc}@{$endif}RDraw;
			PWIDGET(o)^.EventHandler := {$ifdef fpc}@{$endif}REventHandler;
		    end;
		2 : begin
			PWIDGET(o)^.Draw := {$ifdef fpc}@{$endif}GDraw;
			PWIDGET(o)^.EventHandler := {$ifdef fpc}@{$endif}GEventHandler;
		    end;
		3 : begin
			PWIDGET(o)^.Draw := {$ifdef fpc}@{$endif}BDraw;
			PWIDGET(o)^.EventHandler := {$ifdef fpc}@{$endif}BEventHandler;
		    end;	
 	end;
	
	
	o^.a := a;
	PWIDGET(o)^.Flags := PWIDGET(o)^.Flags or WFForceBuffer;
	CreateRGBSel := o;
	end;
end;
(*////////////////////////////////////////////////////////////////////////////////*)
function CreatePaletteSel ( App: PApplication; r: TRect; a: PColSelDat ): PColSelEl;
var o: PColSelEl;
begin
	New(o);
	if not assigned(o) then CreatePaletteSel := NIL else
	begin
	fillchar(o^,sizeof(TColSelEl),0);
	IntialiseWidget(App, StdWidgetClass, PWIDGET(o), r);
	PWIDGET(o)^.Draw := {$ifdef fpc}@{$endif}PaletteSelDraw;
	PWIDGET(o)^.EventHandler := {$ifdef fpc}@{$endif}PaletteSelEventHandler;
	o^.a := a;
	PWIDGET(o)^.Flags := PWIDGET(o)^.Flags or WFForceBuffer;
	CreatePaletteSel := o;
	end;
end;
(*////////////////////////////////////////////////////////////////////////////////*)
procedure BackUpFavorites ( aa: PColSelDat );
var a,b: PListItem;
	Key, Val: l_text;
	i: PColFavItem;
begin	
	DeleteKey('/USER/FAVCOLORS');
	CreateKey('/USER/FAVCOLORS');
	
	if not assigned( aa^.lv^.Items^.Last ) then exit;
	
	a := aa^.lv^.Items^.Last^.Next; b := a; 
	
	repeat
		i := PColFavItem(a^.Data);
		Val := TextArgs('%02x%02x%02x',[i^.r,i^.g,i^.b]);
		Key := TextArgs('/USER/FAVCOLORS/%s',[i^.o.Caption]);
		KeySetText(Key, Val);
		Key:='';
		Val:='';
		a := a^.Next;
	until ( a = b );
end;
(*////////////////////////////////////////////////////////////////////////////////*)
procedure LoadFavorites ( aa: PColSelDat );
var o,a,b: PRegKey; c: integer; 
begin
	o := ResolveKey('/USER/FAVCOLORS'); 
	
	if not assigned( o ) then exit;
	if not assigned( o^.Last ) then exit;
	
	a := o^.Last^.Next; b := a;
	repeat
		
		if ( a^.aType = RKT_TEXT ) then begin
			c := StrToInt(l_text(a^.Data));
			ColFavAddItem(aa^.lv,a^.Name,(c shr 16) and $FF,(c shr 8) and $FF,c and $FF);			
		end;
		
		a := a^.Next;
	until ( a = b );
end;
(*////////////////////////////////////////////////////////////////////////////////*)
const
  MSG_APPLYRGB  = $F0030001;
  MSG_APPLYHSL  = $F0030002;
  MSG_APPLYHTML = $F0030003;
  MSG_ADDFAV    = $F0030004;
  MSG_REMOVE    = $F0030005;
  MSG_SELCOL    = $F0030006;
(*////////////////////////////////////////////////////////////////////////////////*)
function DialogColor ( var rgb: AL_RGB; var col: l_color ): l_bool;
var
 	r: TRect;
	bk: PTabBook;
	t: PTab;
 	l: PLabel;
 	b: PButton;
        c: integer;
	msg: l_ulong;
	a: PColSelDat;
	i: PColFavItem;
	j: PListviewItem;
begin
    New(a);
 	
	a^.r := rgb.r;
	a^.g := rgb.g;
	a^.b := rgb.b;
 	 
	a^.r := getr(col);
	a^.g := getg(col);
	a^.b := getb(col);
 	
	a^.r := 255;
	a^.g := 255;
	a^.b := 0;
	
	al_rgb_to_hsv(a^.r,a^.g,a^.b,a^.h,a^.s,a^.v);
	
	
	RectAssign(r, 0, 0, 265, 270);
	a^.w := CreatePWindow(@Me, r, 'Color selector', WF_CAPTION or WF_FRAME or WF_CENTERED or WF_MINIMIZE);
	InsertWidget(DeskTop, PWIDGET(a^.w));
	

	RectAssign(r, 0, 0, 30, 30);
	a^.col := CreateWidget(@Me,r);
	a^.col^.BackgroundColor := makecol(a^.r,a^.g,a^.b);
	InsertWidget(PWIDGET(a^.w), a^.col);
	
	RectAssign(r, 35, 0, 320,30);
	a^.l := CreateLabel(@Me,r,'');
	PWIDGET(a^.l)^.BackgroundColor := COL_3DFACE;
	InsertWidget(PWIDGET(a^.w), PWIDGET(a^.l));

	RectAssign(r, 0, 35, 265, 240 );
	bk := PTabBook(CreateTabBook(@Me,r));
	InsertWidget(PWIDGET(a^.w), PWIDGET(bk));

	t := TabBookAddTab(bk,'HSV',NIL);

	RectAssign(r, 0, 0, 255, 20);
	a^.hue := CreateHueSel(@Me, r,a);
	InsertWidget(PWIDGET(t), PWIDGET(a^.hue));
	
	RectAssign(r, 0, 30, 128, 158);
	a^.sallgh := CreateSalLghSel(@Me, r,a);
	InsertWidget(PWIDGET(t), PWIDGET(a^.sallgh));
	

	RectAssign(r, 135, 30, 190,50);
	l := CreateLabel(@Me,r,'Hue');
	PWIDGET(l)^.BackgroundColor := COL_3DFACE;
	InsertWidget(PWIDGET(t), PWIDGET(l));

	RectAssign(r, 195, r.a.y, 255, r.b.y);
	a^.th := CreateTextbox(@Me,r,TBF_EDITABLE);
	InsertWidget(PWIDGET(t), PWIDGET(a^.th));
	
	RectAssign(r, 135, r.b.y+5, 190,r.b.y+25 );
	l := CreateLabel(@Me,r,'Sat');
	PWIDGET(l)^.BackgroundColor := COL_3DFACE;
	InsertWidget(PWIDGET(t), PWIDGET(l));

	RectAssign(r, 195, r.a.y, 255, r.b.y);
	a^.ts := CreateTextbox(@Me,r,TBF_EDITABLE);
	InsertWidget(PWIDGET(t), PWIDGET(a^.ts));

	RectAssign(r, 135, r.b.y+5, 190,r.b.y+25 );
	l := CreateLabel(@Me,r,'Value');
	PWIDGET(l)^.BackgroundColor := COL_3DFACE;
	InsertWidget(PWIDGET(t), PWIDGET(l));

	RectAssign(r, 195, r.a.y, 255, r.b.y);
	a^.tv := CreateTextbox(@Me,r,TBF_EDITABLE);
	InsertWidget(PWIDGET(t), PWIDGET(a^.tv));

	RectAssign(r, 135, r.b.y+5, 190,r.b.y+25 );
	b := CreateButton(@Me,r,'Apply',MSG_APPLYHSL);
	InsertWidget(PWIDGET(t), PWIDGET(b));

	
	t := TabBookAddTab(bk,'RGB & HTML',NIL);
	
	RectAssign(r, 0, 0, 55,20);
	l := CreateLabel(@Me,r,'Red');
	PWIDGET(l)^.BackgroundColor := COL_3DFACE;
	InsertWidget(PWIDGET(t), PWIDGET(l));

	RectAssign(r, 60, r.a.y, 123, r.b.y);
	a^.tr := CreateTextbox(@Me,r,TBF_EDITABLE);
	InsertWidget(PWIDGET(t), PWIDGET(a^.tr));
	
	RectAssign(r, 128, r.a.y, 255, r.b.y);
	a^.sr := CreateRGBSel(@Me,r,a,1);
	InsertWidget(PWIDGET(t), PWIDGET(a^.sr));
	
	RectAssign(r, 0, r.b.y+5, 55,r.b.y+25 );
	l := CreateLabel(@Me,r,'Green');
	PWIDGET(l)^.BackgroundColor := COL_3DFACE;
	InsertWidget(PWIDGET(t), PWIDGET(l));

	RectAssign(r, 60, r.a.y, 123, r.b.y);
	a^.tg := CreateTextbox(@Me,r,TBF_EDITABLE);
	InsertWidget(PWIDGET(t), PWIDGET(a^.tg));

	RectAssign(r, 128, r.a.y, 255, r.b.y);
	a^.sg := CreateRGBSel(@Me,r,a,2);
	InsertWidget(PWIDGET(t), PWIDGET(a^.sg));

	RectAssign(r, 0, r.b.y+5, 55,r.b.y+25 );
	l := CreateLabel(@Me,r,'Blue');
	PWIDGET(l)^.BackgroundColor := COL_3DFACE;
	InsertWidget(PWIDGET(t), PWIDGET(l));

	RectAssign(r, 60, r.a.y, 123, r.b.y);
	a^.tb := CreateTextbox(@Me,r,TBF_EDITABLE);
	InsertWidget(PWIDGET(t), PWIDGET(a^.tb));
	
	RectAssign(r, 128, r.a.y, 255, r.b.y);
	a^.sb := CreateRGBSel(@Me,r,a,3);
	InsertWidget(PWIDGET(t), PWIDGET(a^.sb));
	
	RectAssign(r, 0, r.b.y+5, 55,r.b.y+25 );
	b := CreateButton(@Me,r,'Apply',MSG_APPLYRGB);
	InsertWidget(PWIDGET(t), PWIDGET(b));
	
	RectAssign(r, 0, r.b.y+5+10, 55,r.b.y+25+10 );
	l := CreateLabel(@Me,r,'HTML');
	PWIDGET(l)^.BackgroundColor := COL_3DFACE;
	InsertWidget(PWIDGET(t), PWIDGET(l));

	RectAssign(r, 60, r.a.y, 123, r.b.y);
	a^.thtml := CreateTextbox(@Me,r,TBF_EDITABLE);
	InsertWidget(PWIDGET(t), PWIDGET(a^.thtml));

	RectAssign(r, 0, r.b.y+5, 55,r.b.y+25 );
	b := CreateButton(@Me,r,'Apply',MSG_APPLYHTML);
	InsertWidget(PWIDGET(t), PWIDGET(b));
	
	t := TabBookAddTab(bk,'Favorites',NIL);
	
	RectAssign(r, 5, 5, 255, 100);
	a^.lv := CreateListview(@Me,r,'Color name',LVS_LIST,0);
	a^.lv^.OnValMsg := MSG_SELCOL;
	InsertWidget(PWIDGET(t), PWIDGET(a^.lv));
	
	LoadFavorites(a);
	
	RectAssign(r, 5, r.b.y+5, 125, r.b.y+25);
	b := CreateButton(@Me,r,'Remove',MSG_REMOVE);
	InsertWidget(PWIDGET(t), PWIDGET(b));
	
	RectAssign(r, 130, r.a.y, 255, r.b.y);
	b := CreateButton(@Me,r,'Use selected',MSG_SELCOL);
	InsertWidget(PWIDGET(t), PWIDGET(b));

	
	RectAssign(r, 5, r.b.y+5, 200, r.b.y+25);
	a^.tfav := CreateTextbox(@Me,r,TBF_EDITABLE);
	InsertWidget(PWIDGET(t), PWIDGET(a^.tfav));
	
	RectAssign(r, r.b.x+5, r.a.y, 255,r.b.y );
	b := CreateButton(@Me,r,'Add',MSG_ADDFAV);
	InsertWidget(PWIDGET(t), PWIDGET(b));
	
	t := TabBookAddTab(bk,'Palette',NIL);
	
	RectAssign(r, 0, 0, 200,20);
	l := CreateLabel(@Me,r,'Classic pallette');
	PWIDGET(l)^.BackgroundColor := COL_3DFACE;
	InsertWidget(PWIDGET(t), PWIDGET(l));

	RectAssign(r, 0, 20, 80, 80);
	a^.pal := CreatePaletteSel(@Me, r,a);
	InsertWidget(PWIDGET(t), PWIDGET(a^.pal));
	
	
	RectAssign(r, 5, 245, 100,265 );
	b := CreateButton(@Me,r,'OK',MSG_OK);
	InsertWidget(PWIDGET(a^.w), PWIDGET(b));
	
	RectAssign(r, 110, 245, 210,265 );
	b := CreateButton(@Me,r,'Cancel',WM_CLOSE);
	InsertWidget(PWIDGET(a^.w), PWIDGET(b));

	WidgetDrawAll(PWIDGET(a^.w));
	TabBookSelectTab(bk,t);
	UpdateColor(a);
	
	
	msg := WidgetExecute(PWIDGET(a^.w));
	while ( msg <> WM_CLOSE ) do
	begin
                msg := WidgetExecute(PWIDGET(a^.w));
		case msg of
		
			
			MSG_OK:
			begin
				if assigned( @rgb ) then begin
					rgb.r := a^.r;
					rgb.g := a^.g;
					rgb.b := a^.b;
				end;
				col := makecol(a^.r,a^.g,a^.b);
				BackUpFavorites(a);
				WidgetDispose(PWIDGET(a^.w));
				Dispose(a);
				DialogColor := true;
				
			end;

			MSG_REMOVE:
			begin
				j := GetSelectedItem(a^.lv);				
				if assigned( j ) then begin
					ListviewItemRemoveItem(a^.lv,j);
					WidgetDrawAll(PWIDGET(a^.lv));
					if assigned( SLLWDG(a^.lv)^.Vertical ) then WidgetDraw(PWIDGET(SLLWDG(a^.lv)^.Vertical), NIL);
				end;
			end;
	
			MSG_SELCOL:
			begin
				i := PColFavItem(GetSelectedItem(a^.lv));
				if assigned( i ) then begin
					a^.r := i^.r;
					a^.g := i^.g;
					a^.b := i^.b;
					al_rgb_to_hsv(a^.r,a^.g,a^.b,a^.h,a^.s,a^.v);
					UpdateColor(a);
				end;
			end;
			
			MSG_ADDFAV:
			begin
				ColFavAddItem(a^.lv,a^.tfav^.Text,a^.r,a^.g,a^.b);
				WidgetDrawAll(PWIDGET(a^.lv));
				if assigned( SLLWDG(a^.lv)^.Vertical ) then WidgetDraw(PWIDGET(SLLWDG(a^.lv)^.Vertical), NIL);
			end;
			MSG_APPLYHTML:
			begin
				if ( Length(a^.thtml^.Text) > 6 ) then begin
					c := strtoint(a^.thtml^.Text)+1;
					a^.r := (c shr 16) and $FF;
					a^.g := (c shr 8) and $FF;
					a^.b := c and $FF;
					al_rgb_to_hsv(a^.r,a^.g,a^.b,a^.h,a^.s,a^.v);
					UpdateColor(a);
				end;
			end;
			
			MSG_APPLYRGB:
			begin
				a^.r := StrToInt(a^.tr^.Text);
				a^.g := StrToInt(a^.tg^.Text);
				a^.b := StrToInt(a^.tb^.Text);
				if ( a^.r < 0 ) then a^.r := 0;
				if ( a^.g < 0 ) then a^.g := 0;
				if ( a^.b < 0 ) then a^.b := 0;
				if ( a^.r > 255 ) then a^.r := 255;
				if ( a^.g > 255 ) then a^.g := 255;
				if ( a^.b > 255 ) then a^.b := 255;
				al_rgb_to_hsv(a^.r,a^.g,a^.b,a^.h,a^.s,a^.v);
				UpdateColor(a);
			end;
			MSG_APPLYHSL:
			begin
				a^.h := StrToFloat(a^.th^.Text);
				a^.s := StrToFloat(a^.ts^.Text);
				a^.v := StrToFloat(a^.tv^.Text);
				
				if ( a^.h < 0 ) then a^.h := 0;
				if ( a^.s < 0 ) then a^.s := 0;
				if ( a^.v < 0 ) then a^.v := 0;
				
				if ( a^.h > 360 ) then a^.h := 360;
				if ( a^.s > 1 ) then a^.s := 1;
				if ( a^.v > 1 ) then a^.v := 1;
								
				al_hsv_to_rgb(a^.h,a^.s,a^.v,a^.r,a^.g,a^.b);
				UpdateColor(a);
			end;
		end;
		
	end;
	
	
	BackUpFavorites(a);
	WidgetDispose(PWIDGET(a^.w));
	Dispose(a);
	
	
	DialogColor := false;
	
end;
	
	
(*////////////////////////////////////////////////////////////////////////////////*)
function LibMain ( argc: integer; argv: l_text ): l_bool;
begin
	(*RGB rgb;
	DialogColor(rgb,NIL);*)
	(*
	APPEXPORT(DialogColor);
    *)
	LibMain := true;
end;
(*////////////////////////////////////////////////////////////////////////////////*)
procedure Close;
begin

end;
(*////////////////////////////////////////////////////////////////////////////////*)
{$ifdef OPascal}
initialization
{$else}
begin
{$endif}
   AppVersion := ULONG_ID(0,0,0,1);
   
{$endif}  {$LINK_CLIBS}
end.
