(*
///////////////////////////////////////////////////////////////////////////////
// Unit Files.pas
// contains fileaccess routines from c/c++ emulated with freepascal 
///////////////////////////////////////////////////////////////////////////////
*)
unit files;

interface

{$i cdefs.inc}
{$IFDEF LINK_CLIBS}
  {$LINK files.o}
{$ENDIF}

{$ifndef OPascal}
const
 soFromBeginning = 1;
 soFromCurrent   = 2;
 soFromEnd       = 3;
{$endif}

const
 SEEK_SET   = soFromBeginning;
 SEEK_CUR   = soFromCurrent;
 SEEK_END   = soFromEnd;


function FileRead(var struct; size, count: Integer; var pf: PFileStruct): Boolean; {$IFDEF LINK_CLIBS}external;{$ENDIF}
function FileGetPos(var pf: PFileStruct; APosition: Integer): Boolean; {$IFDEF LINK_CLIBS}external;{$ENDIF}
function FileSetPos(var pf: PFileStruct; APosition: Integer): Boolean; {$IFDEF LINK_CLIBS}external;{$ENDIF}

implementation 

{$IFNDEF LINK_CLIBS}

function FileRead(var struct; size, count: Integer; var pf: PFileStruct);
var readed: Integer; i: Integer;
begin
  {$ifdef use_stream}
  if pf <> nil then for i := 1 to Count do pf^.Handle.Read(struct,size);
  {$else}
  if pf <> nil then for i := 1 to Count do BlockRead(pf^, struct, size, readed);
  {$endif}
end;

function FileGetPos(var pf: PFileStruct; var APosition: {$ifdef fpc}{$ifdef LINK_CLIBS}Integer{$else}int64{$endif}{else}Integer{$endif}): Boolean; 
begin
  if pf <> nil then 
  begin
  {$ifdef use_stream}
    {$ifdef fpc}
    APosition := pf^.Handle.Position
    {$else}
    APosition := pf^.Handle.Position
    {$endif}
    FileGetPos := APosition >= 0;
  {$else}
    {$i-}
    APosition := FilePos(pf^.Handle);
    {$i+}
    FileGetPos := (IOResult = 0);
  {$endif}
  end
  else
  begin
    APosition := -1;
    FileGetPos := false;
  end;
end;

function FileSetPos(var pf: PFileStruct; var APosition: Integer): Boolean; 
begin
  {$ifdef use_stream}
   {$ifdef fpc}
     pf^.Handle.Seek(APosition, soFromBeginning);
   {$else} 
     {$ifdef OPascal}
       pf^.Handle.Seek(APosition, soFromBeginning);
     {$else}
       pf^.Handle.Seek(APosition);  
     {$endif}
   {$endif}
  {$else}
     Seek(pf^.Handle, APosition);
  {$endif}
end;

{$ENDIF}

end.
