(*
/////////////////////////////////////////////////////////////////////////////////
//
//	Groupbox Core File 
//
//	Aura Milestone 3 
//
//	(c) Copyright 2012 Finn Technologies and Chase Finn. All rights reserved.
//
/////////////////////////////////////////////////////////////////////////////////
*)
unit groupbox;

interface
  
uses
  guitypes, widget;

{$i cdefs.inc}

{$IFDEF LINK_CLIBS}
   {$LINK widget.o}
   {$LINK groupbox.o}
{$ENDIF}

type
  PGroupbox = ^TGroupbox;
  TGroupbox = record

	o:	TWidget;

	Caption: l_text;

  end;
  GROUPBOX = PGROUPBOX;

{#define GROUPBOX(w)	((PGroupbox)(w))}

function CreateGroupbox( App: PApplication; r: TRect; Caption: l_text ): PGroupbox; {$IFDEF LINK_CLIBS}external;{$endif}


implementation

{$IFNDEF LINK_CLIBS}

{
 .#include "kernel.h"
 .#include "widget.h"
 .#include "groupbox.h"
}
var
  UID       : l_ulong;
  AppVersion: l_ulong;
  
const  
  AppName   : String     = 'Groupbox Widget';
  nUID      : String     = 'groupbox';
  NeededLibs: array[0..2] of String = ( 'widget', 'skin','' );

  SkinGroupbox: PSkin = NIL;

var
  GroupboxClass: PWidgetClass;

procedure GroupboxDraw ( o: PWidget; buffer: p_bitmap; w: PRect );
begin
	DrawSkin(buffer, SkinGroupbox, o^.Absolute.a.x, o^.Absolute.a.y, o^.Absolute.b.x, o^.Absolute.b.y);

	if ( PGROUPBOX(o)^.Caption <> '' ) then
	begin
		rectfill(buffer, o^.Absolute.a.x+10, o^.Absolute.a.y+1, o^.Absolute.a.x+20+text_length(SkinGroupbox^.Font, PGROUPBOX(o)^.Caption), o^.Absolute.a.y+2+text_height(SkinGroupbox^.Font), getpixel(SkinGroupbox^.Skin, SkinGroupbox->Skin^.w/2, SkinGroupbox^.Skin^.h/2));
		textout_ex(buffer, SkinGroupbox^.Font, GROUPBOX(o)^.Caption, o^.Absolute.a.x+18, o^.Absolute.a.y+1, SkinGroupbox^.FontColor, -1);
	end;
end;

function GroupboxEventHandler ( o: PWidget; Ev: PEvent ): l_bool;
begin
	GroupboxEventHandler := false;
end;

function CreateGroupbox( App: PApplication; r: TRect; Caption: l_text ): PGroupbox;
var
  a: TRect;
  p: PGroupbox;
begin
  New(p);
  if not assigned(p) then CreateGroupBox := NIL else
  begin
	fillchar(p, sizeof(TGroupbox), 0);

	p^.Caption := Caption;

	IntialiseWidget(App, GroupboxClass, PWidget(p), r);

	PWidget(p)^.Draw := {$ifdef fpc}@{$endif}GroupboxDraw;
	PWidget(p)^.EventHandler := {$ifdef fpc}@{$endif}GroupboxEventHandler;
	
	RectAssign(a, SkinGroupbox^.Left, 3+text_height(SkinGroupbox^.Font), r.b.x-r.a.x-SkinGroupbox^.Right, r.b.y-r.a.y-SkinGroupbox^.Bottom);
	WidgetSetChildArea(PWidget(p), a );
	
	CreateGroupBox := p;
  end;
end;
(*
	Set a real groupbox property 
*)
function GroupboxSetRProp ( o: PWidget; Name: l_text; Value: l_text; Redraw: l_bool ): l_bool;
begin	
	if ( TextCompare(Name,'caption') := 0 ) then 
	begin
    	if ( PGroupBox(o)^.Caption <> '' ) then PGroupBox(o)^.Caption := '';
		PGroupBox(o)^.Caption := Value;
		if ( Redraw ) then WidgetDraw(PWidget(o), NIL);
		GroupboxSetRProp := true;
	end else
	GroupboxSetRProp := false;
end;
(*
	Get a property from real groupbox  
*)
function GroupboxGetRProp ( o: PWidget; Name: l_text ): PString;
begin	
    if ( TextCompare(Name,'caption') = 0 ) then GroupboxGetRProp := @PGroupBox(o)^.Caption; else
	GroupboxGetRProp := NIL;
end;

function StdCreateGroupbox ( App: PApplication; r: TRect ): PWidget;
begin
	StdCreateGroupbox := PWidget(CreateGroupbox(App,r,'Caption'));
end;

function LibMain ( argc: integer argv: l_text ): l_bool;
begin
	GroupboxClass := CreateWidgetClass( ULONG_ID('G','r','p','B'), StdWidgetClass, WCF_CONTAINER );
	GroupboxClass^.StdCreate := {$ifdef fpc}@{$endif}StdCreateGroupbox;
	GroupboxClass^.SetRProp := {$ifdef fpc}@{$endif}GroupboxSetRProp;
	GroupboxClass^.GetRProp := {$ifdef fpc}@{$endif}GroupboxGetRProp;
	
	WClassRegisterProp(GroupboxClass,PTYPE_STRING,'caption');
	
	SkinGroupbox = GetSkinItem('Groupbox');

	{ APPEXPORT(CreateGroupbox); }

	return true;
end;

procedure Close;
begin

end;

{$ifdef OPascal}
initialization
{$else}
begin
{$endif}
  UID        := ULONG_ID('G','R','P','B');
  AppVersion := ULONG_ID(0,0,0,1);


{$ENDIF} {LINK_CLIBS}
end.
