unit guitypes;
//types.h
//converted to pascal

{ .#ifndef _TYPES_H_INCLUDED_}
{ .#define _TYPES_H_INCLUDED_}

///#include "platform.h"

interface
{$define ALLEGRO_H}
uses
  gdrivers
  {$ifdef ALLEGRO_H}
  ,allegro
  {$endif}

  ;

{$i cdefs.inc}

///**
//*	Variable types
//*/
type
  PFile = ^File;
{typedef	long		}	l_long   = Longint;
{typedef	int		}	l_int    = Integer;
{$ifdef use_allegro}
  PFont = AL_FONTptr;
{$else}
  PFont = gdrivers.PFont;
{$endif}

{$ifdef _OZONE__WIN32_}
{typedef	unsigned _int64	}      	l_ubig   = int64;
{$else}
{typedef	unsigned long long}	l_ubig   = int64;
{$endif}

{typedef	int		}	l_bool   = Longbool;
{typedef	char		}	l_char   = char;
{typedef short	                }	l_short  = Shortint;
{typedef unsigned short	        }	l_ushort = Byte;
{typedef	unsigned char	}	l_byte   = Byte;
                                        l_uchar  = Byte;
{typedef	unsigned int	}	l_word   = LongWord;
                                        l_uint   = Cardinal;
{typedef	unsigned long	}	l_dword  = Longword;
                                        l_ulong  = Cardinal;
                                        l_ulongPtr = ^l_ulong;
{typedef	char		}	l_tag32  = array[0..31] of Char;
{typedef	long		}	l_rect   = Longint;
{typedef	int		}	l_color  = Integer;
{typedef	char*		}	l_text   = AnsiString;
{$ifdef OPascal}
type TArguments = array of l_text;
{$else}
type TArguments = PDynamicArray;
{$endif}
{typedef	short*		}       l_utext  = UnicodeString;   // Unicode text //oder WideString
{typedef double			}       l_double = Double;
{typedef	void*		}	l_ptr    = Pointer;

{typedef char               }   l_uid    = array[0..13-1] of Char; // Use only 12 first bytes. (13th byte must be '\0') (UTF-8)
  
{$ifdef ALLEGRO_H}
{typedef	BITMAP*		    }	p_bitmap = AL_BITMAPptr;
{typedef	BITMAP*		    }	PImage   = AL_BITMAPptr;
{$else}
                                        p_bitmap = PCanvas;
                                        PImage   = p_bitmap;
{$endif}
//typedef RLE_SPRITE*		PRleSprite;
PRleSprite = AL_RLE_SPRITEptr;

{ .#define IMAGE(o) ((PImage)(o))        }
{ .#define RLESPRITE(o) ((PRleSprite)(o))}




{typedef	l_int			}	t_message = Integer;
{typedef	void*			}	t_pointer = Pointer;
{typedef	t_pointer		}	t_data    = Pointer;

///**
//*	DMS specific (see dms.h)
//*/
{typedef  unsigned long		}   l_datatype = Cardinal;
{typedef  void*			}   l_data     = Pointer;
{typedef  unsigned long		}   l_dataencode = Cardinal;

const
 TYPE_UNKNOW_BINARY = 0;
 TYPE_TEXT          = 1;
 TYPE_UTEXT         = 2;
 TYPE_IMAGE         = 3;
 TYPE_ICON          = 4;
 TYPE_CURSOR        = 5;
 TYPE_LIST          = 6;
 TYPE_FILEREF       = 7;
 TYPE_FILEREFLIST   = 8;

// Standart data types
 DTYPE_TEXT         = $00000001;
 DTYPE_UTEXT        = $00000002;
 DTYPE_IMAGE        = $00000003;
 DTYPE_ICON         = $00000004;
 DTYPE_CURSOR       = $00000005;
 DTYPE_LIST         = $00000006;
 DTYPE_RESSOURCE    = DTYPE_LIST;
 DTYPE_FILEREF      = $00000007;
 DTYPE_FILEREFLIST  = $00000008;
 DTYPE_SOUNDSTREAM  = $00000009;
 DTYPE_IWIDGET      = $00000010;
 DTYPE_APPINFO      = $00000011; // Type not yet defined
 DTYPE_BINDATA   	= $FFFFFFFF;

type
  PBinData = ^TBinData;
  TBinData = record
	
	Data: Pointer;	
	Size: l_ulong;
	
  end;

{#define BINDATA(o) ((PBinData)(o))}

{$ifdef SIMPLECOLOR}
	type TSColor = Longword; PSColor = ^TSColor;
{$else}
type
  PSColor = ^TSColor;
  TSColor = record
    idx: l_uchar;
    r, g, b: l_uchar;
  end;
{$endif}

(*
#ifndef LOWORD
#define LOWORD(w)	(((w)<<16)>>16)
#endif

#ifndef HIWORD
#define HIWORD(w)	((w)>>16)
#endif

#ifndef NULL
#define NULL ((void * )0)
#endif

#ifndef true
#define true 1
#endif

#ifndef false
#define false 0
#endif

#ifndef TRUE
#define TRUE true
#endif

#ifndef FALSE
#define FALSE false
#endif

#ifndef max
#define max(a,b) ((a)>(b)?(a):(b))
#endif

#ifndef min
#define min(a,b) ((a)<(b)?(a):(b))
#endif
*)

function ULONG_ID(a, b, c, d: char): Longword; overload;
function ULONG_ID(a, b, c, d: byte): Longword; overload;

function LONG_ID(d, c, b, a: char): Longword; overload;
function LONG_ID(d, c, b, a: byte): Longword; overload;


function ULID_A(var v): Longword; 
function ULID_B(var v): Longword; 
function ULID_C(var v): Longword; 
function ULID_D(var v): Longword; 

///**
//*	Usefull MACRO tools
//*/
function CLEAR(var o)   : Boolean;
function RGB(r,g,b: Byte) : Longword;
function DoSET(s,o: Longword): Longword;
function UNSET(s,o: Longword): Longword;

// See DMS2.C and DMS2.H for informations on PIcon funtions
{$ifdef ALLEGRO_H}

type
  PIcon = ^TIcon;
  TIcon = record
	
	Instances: l_ulong;
	
	Icon16: PRleSprite;
	Icon32: PRleSprite;
	Icon48: PRleSprite;
	
  end;
{$else}
type
  PIcon = Pointer;
{$endif}

type
  PLongword = {$ifdef OPascal}^Longword{$else}^Longint{$endif};
  PInteger  = ^Integer;
  PLUINT    = {$ifdef OPascal}^Cardinal{$else}^Longint{$endif};

{ .#endif /* _TYPES_H_INCLUDED_ }

// Gateways types (FMS stuff)
var
 DTYPE_DYNLD 	: Longword;
 DTYPE_DOSEXE 	: Longword;
 DTYPE_DIRECTORY: Longword;

implementation

function ULONG_ID(a, b, c, d: char): Longword;
begin
  ULONG_ID := ((ord(a) shl 24) or (ord(b) shl 16) or (ord(c) shl 8) or ord(d));
end;

function ULONG_ID(a, b, c, d: Byte): Longword;
begin
  ULONG_ID := ((a shl 24) or (b shl 16) or (c shl 8) or d);
end;

function LONG_ID(d, c, b, a: char): Longword;
begin
  LONG_ID := ((ord(a) shl 24) or (ord(b) shl 16) or (ord(c) shl 8) or ord(d));
end;

function LONG_ID(d, c, b, a: Byte): Longword; 
begin
  LONG_ID := ((a shl 24) or (b shl 16) or (c shl 8) or d);
end;

function ULID_A(var v): Longword;
begin
  ULID_A := ((Longword(v) and $FF000000) shr 24);
end;

function ULID_B(var v): Longword; 
begin
  ULID_B := ((Longword(v) and $00FF0000) shr 16);
end;

function ULID_C(var v): Longword; 
begin
  ULID_C := ((Longword(v) and $0000FF00) shr 8);
end;

function ULID_D(var v): Longword;
begin
 ULID_D := (Longword(v) and $000000FF)
end;

///**
//*	Usefull MACRO tools
//*/
function CLEAR(var o): Boolean;
begin
  if Pointer(o)<>nil then fillchar(o, 0, sizeof(Pointer(o)));
  CLEAR := Pointer(o)<>nil;
end;

function RGB(r,g,b: byte): Longword;
type
  TConvColor = record
    case longword of
     0: (color: Longword);
     1: (red, green, blue: byte);
  end;
var
  c: TConvColor;
begin
  //makecol(r, g, b)
  c.red   := r;
  c.green := g;
  c.blue  := b;
  RGB := c.Color;
end;

function DoSET(s,o: Longword): Longword;
begin
  s := s or o;
end;

function UNSET(s,o: Longword): Longword;
begin
  s := s and (not o);
  UNSET := s;
end;

initialization
// Gateways types (FMS stuff)
 DTYPE_DYNLD 		:= ULONG_ID('D','y','n','L');
 DTYPE_DOSEXE 		:= ULONG_ID('D','E','x','e');
 DTYPE_DIRECTORY 	:= ULONG_ID('D','i','r',' ');


end.
