unit precscr;
{
 .#include "kernel.h"
 .#include "widget.h"
 .#include "skin.h"
 .#include "prevscr.h"
}
interface

uses guitypes,widget,skin;

{$i cdefs.inc}

{$ifdef LINK_CLIBS}
  {$link widget.o}
  {$link skin.o}
  {$link prevscr.o}
{$endif}

type
  PPrevScr = ^TPrevScr;
  TPrevScr = record
	
	o    :	TWidget;

	Scr  :  p_bitmap;	
	
  end;
  PREVSCR = PPrevScr;

procedure PrevScrSetScr ( o: PPrevScr; scr: p_bitmap ); {$ifdef LINK_CLIBS}external;{$endif}
function CreatePrevScr ( App: PApplication; r: TRect; scr: p_bitmap ): PPrevScr; {$ifdef LINK_CLIBS}external;{$endif}

implementation
{$ifndef LINK_CLIBS}

var
  AppVersion: l_ulong;

const
  AppName: l_text = 'Screen preview';
  nUID = 'prevsrc';
  NeededLibs: l_uid = ( 'widget','skin','' );

  ScrImg: p_bitmap = NIL;

var PrevScrClass: PWidgetClass;

procedure PrevScrDraw (o: PWidget; buffer: p_bitmap; w: PRect);
begin
	rectfill(buffer, w^.a.x, w^.a.y, w^.b.x, w^.b.y, o^.BackgroundColor);
	draw_sprite(buffer,ScrImg,o^.Absolute.a.x,o^.Absolute.a.y);
	if ( PPREVSCR(o)^.Scr )
		draw_sprite(buffer,PPREVSCR(o)^.Scr,o^.Absolute.a.x+14,o^.Absolute.a.y+16);

end;

procedure PrevScrSetScr ( o: PPrevScr; scr: p_bitmap );
begin
	o^.Scr := Scr;	
	WidgetDraw(PWIDGET(o),NIL);
end;


function CreatePrevScr ( App: PApplication; r: TRect; scr: p_bitmap ): PPrevScr;
begin
	PPrevScr o = malloc(sizeof(TPrevScr));
	if not assigned(o) then CreatePrevScr := NIL else
	begin
    	fillchar(o^, sizeof(TPrevScr), 0);
    	o^.Scr := Scr;
    	IntialiseWidget(App, PrevScrClass, PWIDGET(o), r );
    	PWIDGET(o)^.BackgroundColor = COL_3DFACE;
    	PWIDGET(o)^.Flags |= WFForceBuffer;
    	PIDGET(o)^.Draw = &PrevScrDraw;
    	CreatePrevScr := o;
	end;
end;

function  StdCreatePrevScr ( App: PApplication; r: TRect ): PWidget;
begin
	StdCreatePrevScr := WIDGET(CreatePrevScr(App,r,NIL));
end;

function LibMain ( argc: integer; argv: l_text ): l_bool;
begin
	
	PrevScrClass := CreateWidgetClass( ULONG_ID('P','S','c','r'), StdWidgetClass, 0 );
	PrevScrClass^.StdCreate = &StdCreatePrevScr;

	
	if assigned( Me.Ressource ) then
	begin
		ScrImg := ListKey(Me.Ressource,'SCREEN');
	end;
    (*
	APPEXPORT(CreatePrevScr);
	APPEXPORT(PrevScrSetScr);
	*)
	LibMain := true;
end;

void Close (void)
begin

end;

{$ifdef OPascal}
initialization
{$else}
begin
{$endif}
  AppVersion := ULONG_ID(0,0,1,0);

{$endif}  {LINK_CLIBS}
end.

