(*
/////////////////////////////////////////////////////////////////////////////////
//
//	Tabbook Core File 
//
//	Aura Milestone 3 
//
//	(c) Copyright 2012 Finn Technologies and Chase Finn. All rights reserved.
//
/////////////////////////////////////////////////////////////////////////////////
*)
unit tabbook;
(*
  #include "kernel.h"
  #include "tabbook.h"
  #include "grfx.h"
  #include "widget.h"
*)

interface

uses guitypes,dynld,events,mousedrv,metrics,grfx,widget,skin,font,allegro;

{$i cdefs.inc}

{$ifdef LINK_CLIBS}
  {$LINK kernel.o}
  {$LINK tabbook.o}
  {$LINK grfx.o}
  {$LINK widget.o}
{$endif}

type
  PTab = ^TTab;
  TTab = record
  
	o         : TWidget;

	Title     : l_text;
	Icon      : p_bitmap;

	BtCache   : TRect;
  end;

type
  PTabBook = ^TTabBook;
  TTabBook = record

	o     : TWidget;

	Current : PTab;

	max   : l_ulong;
	Pos   : l_ulong;

	Flags : l_ulong;
  end;

const
  TBF_LDWN = $01;
  TBF_RDWN = $02;

function CreateTabBook ( App:PApplication; r:TRect ): PWidget; {$ifdef LINK_CLIBS}external;{$endif}
function TabBookAddTab ( o: PTabBook; Title: l_text; Icon: p_bitmap ): PTab; {$ifdef LINK_CLIBS}external;{$endif}
procedure TabBookDisposeTab ( o:PTabBook; t:PTab ); {$ifdef LINK_CLIBS}external;{$endif}
procedure TabBookRemoveTab ( o:PTabBook; t:PTab ); {$ifdef LINK_CLIBS}external;{$endif}
procedure TabBookSelectTab ( o:PTabBook; t:PTab ); {$ifdef LINK_CLIBS}external;{$endif}

implementation
{$ifndef LINK_CLIBS}

var
 AppVersion: l_ulong;
 TabClass: PWidgetClass;
 TabBookClass: PWidgetClass;
 
const 
 AppName: l_text	= 'TabBook Widget';
 nUID	: l_text	= 'tabbook';
 NeededLibs: array [0..3] of l_text	= ( 'widget', 'grfx', 'skin', '' );

var
 SkinTabOpen: PSkin;
 SkinTabClose: PSkin;
 SkinTabBackground: PSkin;
 SkinTabContainer: PSkin;


procedure NonSkinTabBookDraw ( o:PWidget; buffer:p_bitmap; w:PRect );
var
  ww,x,y: Integer; a,b: PWidget;
begin
	x := o^.Absolute.a.x+2-PTABBOOK(o)^.Pos; y := o^.Absolute.a.y;
	al_rectfill(buffer,w^.a.x,w^.a.y,w^.b.x,w^.b.y,COL_3DFACE);

	al_vline(buffer,o^.Absolute.a.x,o^.Absolute.a.y+20,o^.Absolute.b.y,COL_3DLIGHT);
	al_vline(buffer,o^.Absolute.b.x,o^.Absolute.a.y+20,o^.Absolute.b.y,COL_3DDARK);
	al_hline(buffer,o^.Absolute.a.x,o^.Absolute.b.y,o^.Absolute.b.x,COL_3DDARK);
	al_hline(buffer,o^.Absolute.a.x,o^.Absolute.a.y+19,o^.Absolute.b.x,COL_3DLIGHT);


	if assigned( o^.Last ) then begin
		a := o^.Last;
		b := a;

		repeat
			RectAssign(PTAB(a)^.BtCache,x,y+1,x+al_text_length(default_font,PTAB(a)^.Title)+6,y+18);


			if ( PTAB(a)^.BtCache.b.x  < o^.Absolute.b.x-20 ) then begin

				al_textout_ex(buffer, default_font, PTAB(a)^.Title,x+3,y+2, COL_3DTEXT, -1);

				if ( PTAB(a) = PTABBOOK(o)^.Current ) then begin
					al_hline(buffer,PTAB(a)^.BtCache.a.x-1,PTAB(a)^.BtCache.a.y-1,PTAB(a)^.BtCache.b.x+1,COL_3DLIGHT);
					al_vline(buffer,PTAB(a)^.BtCache.a.x-1,PTAB(a)^.BtCache.a.y-1,PTAB(a)^.BtCache.b.y,COL_3DLIGHT);
					al_vline(buffer,PTAB(a)^.BtCache.b.x+1,PTAB(a)^.BtCache.a.y-1,PTAB(a)^.BtCache.b.y,COL_3DDARK);
					al_hline(buffer,PTAB(a)^.BtCache.a.x,o^.Absolute.a.y+19,PTAB(a)^.BtCache.b.x,COL_3DFACE);
				end else begin
					al_hline(buffer,PTAB(a)^.BtCache.a.x+1,PTAB(a)^.BtCache.a.y,PTAB(a)^.BtCache.b.x,COL_3DLIGHT);
					if ( (PTAB(a^.Next) <> PTABBOOK(o)^.Current) or (a = b) ) then
                      al_vline(buffer,PTAB(a)^.BtCache.a.x,PTAB(a)^.BtCache.a.y,PTAB(a)^.BtCache.b.y,COL_3DLIGHT);
					if ( (PTAB(a^.Prev) <> PTABBOOK(o)^.Current) or (a^.Prev = b) ) then
                      al_vline(buffer,PTAB(a)^.BtCache.b.x,PTAB(a)^.BtCache.a.y,PTAB(a)^.BtCache.b.y,COL_3DDARK);
				end;

			end else if ( x  < o^.Absolute.b.x-20 ) then begin

				ww := o^.Absolute.b.x-20-x;

				if ( ww > 3 ) then DrawNiceText(buffer, default_font,x+3,y+2, ww-3, PTAB(a)^.Title, COL_3DTEXT);

				if ( PTAB(a) = PTABBOOK(o)^.Current ) then begin
					al_hline(buffer,x,y,o^.Absolute.b.x-20,COL_3DLIGHT);
					al_vline(buffer,x,y,y+18,COL_3DLIGHT);
					{//al_vline(buffer,o^.Absolute.b.x-20,y,y+18,COL_3DDARK);}
					al_hline(buffer,x+1,o^.Absolute.a.y+19,o^.Absolute.b.x-20,COL_3DFACE);
				end else begin
					al_hline(buffer,x+1,y+1,o^.Absolute.b.x-20,COL_3DLIGHT);
					if ( (PTAB(a^.Next) <> PTABBOOK(o)^.Current) or (a = b) ) then
						al_vline(buffer,x,y+1,y+18,COL_3DLIGHT);
					(*if ( (PTAB(a^.Prev) <> PTABBOOK(o)^.Current) or (a^.Prev = b) )
						al_vline(buffer,o^.Absolute.b.x-20,y+1,y+18,COL_3DDARK);*)
				end;             
			end;


			x := PTAB(a)^.BtCache.b.x + 1;

			a := a^.Prev;
		until ( a = b );

		PTABBOOK(o)^.Max := x-o^.Absolute.a.x-2+PTABBOOK(o)^.Pos;

		if ( PTABBOOK(o)^.Max > o^.Absolute.b.x-22-o^.Absolute.a.x ) then begin
			if ( PTABBOOK(o)^.Flags and TBF_LDWN ) = TBF_LDWN then
				Rect3D(buffer,o^.Absolute.b.x-19,o^.Absolute.a.y,o^.Absolute.b.x-10,o^.Absolute.a.y+18,COL_3DDARK,COL_3DLIGHT)
			else
				Rect3D(buffer,o^.Absolute.b.x-19,o^.Absolute.a.y,o^.Absolute.b.x-10,o^.Absolute.a.y+18,COL_3DLIGHT,COL_3DDARK);

			if ( PTABBOOK(o)^.Flags and TBF_RDWN ) = TBF_RDWN then
				Rect3D(buffer,o^.Absolute.b.x-9,o^.Absolute.a.y,o^.Absolute.b.x,o^.Absolute.a.y+18,COL_3DDARK,COL_3DLIGHT)
			else
				Rect3D(buffer,o^.Absolute.b.x-9,o^.Absolute.a.y,o^.Absolute.b.x,o^.Absolute.a.y+18,COL_3DLIGHT,COL_3DDARK);

			al_textout_ex(buffer, default_font, '<',o^.Absolute.b.x-17,o^.Absolute.a.y+2, COL_3DTEXT, -1);
			al_textout_ex(buffer, default_font, '>',o^.Absolute.b.x-7,o^.Absolute.a.y+2, COL_3DTEXT, -1);

		end;

	end;
end;

procedure SkinTabBookDraw (o:PWidget; buffer:p_bitmap; w:PRect);
var x,y,ww: integer; a,b: PWidget;
begin
	x := o^.Absolute.a.x - PTABBOOK(o)^.Pos;
	y := o^.Absolute.a.y;

	DrawSkin(buffer, SkinTabBackground, o^.Absolute.a.x, o^.Absolute.a.y, o^.Absolute.b.x, o^.Absolute.b.y);

	if assigned( o^.Last ) then
	begin
		a := o^.Last;
		b := a;

		DrawSkin(buffer, SkinTabContainer, o^.Absolute.a.x, o^.Absolute.a.y + SkinTabOpen^.Skin^.h, o^.Absolute.b.x, o^.Absolute.b.y);

		repeat
		
			RectAssign(&PTAB(a)^.BtCache, x, y, x + al_text_length(default_font, PTAB(a)^.Title) + SkinTabOpen^.Left + SkinTabOpen^.Right, y + SkinTabOpen^.Skin^.h);


			if ( PTAB(a)^.BtCache.b.x  < o^.Absolute.b.x-((SkinTabOpen^.Left + SkinTabOpen^.Right + al_text_length(default_font, '>'))*2) ) then
			begin
				if ( PTAB(a) = PTABBOOK(o)^.Current ) then
				begin
					DrawSkin(buffer, SkinTabOpen, PTAB(a)^.BtCache.a.x, PTAB(a)^.BtCache.a.y, PTAB(a)^.BtCache.b.x, PTAB(a)^.BtCache.b.y);
				end
				else
				begin
					DrawSkin(buffer, SkinTabClose, PTAB(a)^.BtCache.a.x, PTAB(a)^.BtCache.a.y, PTAB(a)^.BtCache.b.x, PTAB(a)^.BtCache.b.y);
				end;

				al_textout_centre_ex(buffer, default_font, PTAB(a)^.Title, (PTAB(a)^.BtCache.a.x+PTAB(a)^.BtCache.b.x) div 2, (PTAB(a)^.BtCache.a.y+PTAB(a)^.BtCache.b.y-al_text_height(default_font)) div 2, COL_3DTEXT, -1);
			end
			else if ( x  < o^.Absolute.b.x - ((SkinTabOpen^.Left + SkinTabOpen^.Right + al_text_length(default_font, '>'))*2) ) then
			begin
				ww := o^.Absolute.b.x-((SkinTabOpen^.Left + SkinTabOpen^.Right + al_text_length(default_font, '>'))*2)-x;

				if ( PTAB(a) = PTABBOOK(o)^.Current ) then
				begin
					(*al_hline(buffer,x,y,o^.Absolute.b.x-20,COL_3DLIGHT);
					al_vline(buffer,x,y,y+18,COL_3DLIGHT);
					//al_vline(buffer,o^.Absolute.b.x-20,y,y+18,COL_3DDARK);
					al_hline(buffer,x+1,o^.Absolute.a.y+19,o^.Absolute.b.x-20,COL_3DFACE);*)
					DrawSkin(buffer, SkinTabOpen, x, y, o^.Absolute.b.x, y + SkinTabOpen^.Skin^.h);
				end
				else
				begin
					(*al_hline(buffer,x+1,y+1,o^.Absolute.b.x-20,COL_3DLIGHT);
					if ( (PTAB(a^.Next) <> PTABBOOK(o)^.Current) or (a = b) ) then
						al_vline(buffer,x,y+1,y+18,COL_3DLIGHT);*)
					DrawSkin(buffer, SkinTabClose, x, y, o^.Absolute.b.x, y + SkinTabOpen^.Skin^.h);
				end;

				if ( ww > 3 ) then DrawNiceText(buffer, default_font, x + SkinTabOpen^.Left, y + (SkinTabOpen^.Skin^.h - al_text_height(default_font)) div 2, ww - 3, PTAB(a)^.Title, COL_3DTEXT);
			end;


			x := PTAB(a)^.BtCache.b.x;

			a := a^.Prev;
		until ( a = b );

		PTABBOOK(o)^.Max := x-o^.Absolute.a.x - 2 + PTABBOOK(o)^.Pos;

		if ( PTABBOOK(o)^.Max > o^.Absolute.b.x-o^.Absolute.a.x - ((SkinTabOpen^.Left + SkinTabOpen^.Right + al_text_length(default_font, '>'))*2) ) then
		begin
			if ( PTABBOOK(o)^.Flags and TBF_LDWN ) = TBF_LDWN then
				DrawSkin(buffer, SkinTabOpen, o^.Absolute.b.x - ((SkinTabOpen^.Left + SkinTabOpen^.Right + al_text_length(default_font, '>'))*2), y, o^.Absolute.b.x - (SkinTabOpen^.Left + SkinTabOpen^.Right + al_text_length(default_font, '>')), y + SkinTabOpen^.Skin^.h)
			else
				DrawSkin(buffer, SkinTabClose, o^.Absolute.b.x - ((SkinTabOpen^.Left + SkinTabOpen^.Right + al_text_length(default_font, '>'))*2), y, o^.Absolute.b.x - (SkinTabOpen^.Left + SkinTabOpen^.Right + al_text_length(default_font, '>')), y + SkinTabOpen^.Skin^.h);

			al_textout_centre_ex(buffer, default_font, '<',((o^.Absolute.b.x - ((SkinTabOpen^.Left + SkinTabOpen^.Right + al_text_length(default_font, '>'))*2))+(o^.Absolute.b.x - (SkinTabOpen^.Left + SkinTabOpen^.Right + al_text_length(default_font, '>')))) div 2, y + (SkinTabOpen^.Skin^.h - al_text_height(default_font)) div 2, COL_3DTEXT, -1);

			if ( PTABBOOK(o)^.Flags and TBF_RDWN ) = TBF_RDWN then
				DrawSkin(buffer, SkinTabOpen, o^.Absolute.b.x - (SkinTabOpen^.Left + SkinTabOpen^.Right + al_text_length(default_font, '>')), y, o^.Absolute.b.x, y + SkinTabOpen^.Skin^.h)
			else
				DrawSkin(buffer, SkinTabClose, o^.Absolute.b.x - (SkinTabOpen^.Left + SkinTabOpen^.Right + al_text_length(default_font, '>')), y, o^.Absolute.b.x, y + SkinTabOpen^.Skin^.h);

			al_textout_ex(buffer, default_font, '>',((o^.Absolute.b.x - (SkinTabOpen^.Left + SkinTabOpen^.Right + al_text_length(default_font, '>')))+(o^.Absolute.b.x)) div 2, y + (SkinTabOpen^.Skin^.h - al_text_height(default_font)) div 2, COL_3DTEXT, -1);

		end;
	end;
end;

procedure TabBookSelectTab ( o: PTabBook; t: PTab );
begin
	if assigned( o^.Current ) then PWIDGET(o^.Current)^.Flags := PWIDGET(o^.Current)^.Flags and not WFVisible;
	o^.Current := t;
	PWIDGET(o^.Current)^.Flags := PWIDGET(o^.Current)^.Flags or WFVisible;
	WidgetDrawAll(PWIDGET(o));
end;

procedure TabBookRemoveTab ( o: PTabBook; t: PTab );
begin
	WidgetRemove(PWIDGET(o), PWIDGET(t));
end;

procedure TabBookDisposeTab ( o: PTabBook; t: PTab );
begin
	WidgetDispose(PWIDGET(t));
end;

function TabBookAddTab ( o: PTabBook; Title: l_text; Icon: p_bitmap ): PTab;
var t:PTab; r:TRect;
begin
	New(t);
	if not assigned( t ) then TabBookAddTab := NIL else
	
	fillchar(t, sizeof(TTab), 0);

	r := PWIDGET(o)^.Relative;

	if (UseSkins) then
		RectAssign(r,SkinTabContainer^.Left, SkinTabOpen^.Skin^.h + 1 + SkinTabContainer^.Top, r.b.x-r.a.x-SkinTabContainer^.Left, r.b.y-r.a.y-SkinTabContainer^.Bottom)
	else
		RectAssign(r,3,23,r.b.x-r.a.x-3,r.b.y-r.a.y-3);


	IntialiseWidget(PWIDGET(o)^.AppOwner,TabClass, PWIDGET(t), r );

	PWIDGET(t)^.Flags := PWIDGET(t)^.Flags and not WFVisible;
	PWIDGET(t)^.BackgroundColor := COL_3DFACE;

	t^.Title	:= Title;
	t^.Icon		:= Icon;

	if not assigned(PWIDGET(o)^.Last) then TabBookSelectTab(o, t);

	InsertWidget(PWIDGET(o), PWIDGET(t));

	TabBookAddTab := t;
end;

function NonSkinTabBookEventHandler ( o: PWidget; Ev: PEvent ): l_bool;
var
  w: l_ulong; a,b: PWidget;
begin
	if (Ev^.aType = EV_MOUSE) then
	begin
		if (Ev^.Message = WEvMouseLDown) then
		begin
			w := o^.Absolute.b.x-22-o^.Absolute.a.x;

			if ( (PTABBOOK(o)^.Max > w) and (Mouse^.State.p.y < o^.Absolute.a.y+20) and (Mouse^.State.p.x > o^.Absolute.b.x-20) ) then
			begin
				if ( Mouse^.State.p.x < o^.Absolute.b.x-10 ) then begin
					PTABBOOK(o)^.Flags := PTABBOOK(o)^.Flags or TBF_LDWN;
				end else begin
					PTABBOOK(o)^.Flags := PTABBOOK(o)^.Flags or TBF_RDWN;
				end;

				WidgetDraw(o,NIL);
				NonSkinTabBookEventHandler := true;
			end;
		end;

		if (Ev^.Message = WEvMouseLUp) then
		begin
			w := o^.Absolute.b.x-22-o^.Absolute.a.x;

			if ( (PTABBOOK(o)^.Max > w) and (Mouse^.State.p.y < o^.Absolute.a.y+20) and (Mouse^.State.p.x > o^.Absolute.b.x-20) ) then
			begin
				if ( Mouse^.State.p.x < o^.Absolute.b.x-10 ) then begin
					if ( PTABBOOK(o)^.Pos > 0 ) then
						PTABBOOK(o)^.Pos := PTABBOOK(o)^.Pos - 10;
				end else begin
					if ( PTABBOOK(o)^.Pos < PTABBOOK(o)^.Max-w+10 ) then
						PTABBOOK(o)^.Pos := PTABBOOK(o)^.Pos + 10;
				end;
				PTABBOOK(o)^.Flags := PTABBOOK(o)^.Flags and not (TBF_LDWN or TBF_RDWN);
				WidgetDraw(o,NIL);
				NonSkinTabBookEventHandler := true;
			end;

			if assigned( o^.Last ) then begin
				a := o^.Last;
				b := a;
				repeat 
					if ( CURSOR_IN_RECT(PTAB(a)^.BtCache) ) then begin
						TabBookSelectTab(PTABBOOK(o),PTAB(a));
						NonSkinTabBookEventHandler := true;
					end;
					a := a^.Prev;
				until ( a = b );
			end;
			NonSkinTabBookEventHandler := true;
		end;
	end else

	NonSkinTabBookEventHandler := false;
end;


function SkinTabBookEventHandler ( o:PWidget; Ev:PEvent ): l_bool;
var
  a,b: PWidget; w: l_ulong;
begin
	if (Ev^.aType = EV_MOUSE) then
	begin
		if (Ev^.Message = WEvMouseLDown) then
		begin
			w := o^.Absolute.b.x-((SkinTabOpen^.Left + SkinTabOpen^.Right + al_text_length(default_font, '>'))*2)-o^.Absolute.a.x;

			if ((PTABBOOK(o)^.Max > w) and (Mouse^.State.p.y < o^.Absolute.a.y+((SkinTabOpen^.Left + SkinTabOpen^.Right + al_text_length(default_font, '>'))*2)) and
                (Mouse^.State.p.x > o^.Absolute.b.x-((SkinTabOpen^.Left + SkinTabOpen^.Right + al_text_length(default_font, '>'))*2))) then
			begin
				if ( Mouse^.State.p.x < o^.Absolute.b.x-((SkinTabOpen^.Left + SkinTabOpen^.Right + al_text_length(default_font, '>')))) then
				begin
					PTABBOOK(o)^.Flags := PTABBOOK(o)^.Flags or TBF_LDWN;
				end
				else
				begin
					PTABBOOK(o)^.Flags := PTABBOOK(o)^.Flags or TBF_RDWN;
				end;

				WidgetDraw(o,NIL);
				SkinTabBookEventHandler := true;
			end;
		end;

		if (Ev^.Message = WEvMouseLUp) then
		begin
			w := o^.Absolute.b.x-((SkinTabOpen^.Left + SkinTabOpen^.Right + al_text_length(default_font, '>'))*2)-o^.Absolute.a.x;

			if ((PTABBOOK(o)^.Max > w) and 
                (Mouse^.State.p.y < o^.Absolute.a.y+((SkinTabOpen^.Left + SkinTabOpen^.Right + al_text_length(default_font, '>'))*2)) and 
                (Mouse^.State.p.x > o^.Absolute.b.x-((SkinTabOpen^.Left + SkinTabOpen^.Right + al_text_length(default_font, '>'))*2))) then
			begin
				if ( Mouse^.State.p.x < o^.Absolute.b.x-((SkinTabOpen^.Left + SkinTabOpen^.Right + al_text_length(default_font, '>'))) ) then
				begin
					if ( PTABBOOK(o)^.Pos > 0 ) then
						PTABBOOK(o)^.Pos := PTABBOOK(o)^.Pos - 10;
				end
				else
				begin
					if ( PTABBOOK(o)^.Pos < PTABBOOK(o)^.Max-w+((SkinTabOpen^.Left + SkinTabOpen^.Right + al_text_length(default_font, '>')))) then
						PTABBOOK(o)^.Pos := PTABBOOK(o)^.Pos + 10;
				end;

				PTABBOOK(o)^.Flags := PTABBOOK(o)^.Flags and not(TBF_LDWN or TBF_RDWN);
				WidgetDraw(o,NIL);

				SkinTabBookEventHandler := true;
			end;

			if assigned( o^.Last ) then
			begin
				a := o^.Last;
				b := a;

				repeat
				
					if ( CURSOR_IN_RECT(PTAB(a)^.BtCache) ) then
					begin
						TabBookSelectTab(PTABBOOK(o),PTAB(a));
						SkinTabBookEventHandler := true;
					end;
					a := a^.Prev;
				
				until ( a = b );
			end;
			SkinTabBookEventHandler := true;
		end;
	end else

	SkinTabBookEventHandler := false;
end;

function CreateTabBook ( App:PApplication; r:TRect ): PWidget;
var o: PTabBook;
begin
	New(o);
	if assigned( o ) then CreateTabBook := NIL else
	begin
    	  fillchar(o, sizeof(TTabBook), 0);

    	  IntialiseWidget(App, TabBookClass, PWIDGET(o), r);

    	  if (UseSkins) then
    	  begin
    		PWIDGET(o)^.Draw	:= {$ifdef fpc}@{$endif}SkinTabBookDraw;
    		PWIDGET(o)^.EventHandler := {$ifdef fpc}@{$endif}SkinTabBookEventHandler;
    	  end
    	  else
    	  begin
    		PWIDGET(o)^.Draw	:= {$ifdef fpc}@{$endif}NonSkinTabBookDraw;
    		PWIDGET(o)^.EventHandler := {$ifdef fpc}@{$endif}NonSkinTabBookEventHandler;
    	  end;

    	  CreateTabBook := PWidget(o);
	end;
end;

function LibMain ( argc: integer; argv: l_text ): l_bool;
var
  o: PTabBook;
  r: TRect;
begin	
	TabBookClass := CreateWidgetClass( ULONG_ID('T','B','c','k'), StdWidgetClass, WCF_BOOK or WCF_CONTAINER );
	TabBookClass^.StdCreate := {$ifdef fpc}@{$endif}CreateTabBook;
	
	TabClass := CreateWidgetClass( ULONG_ID('T','a','b',' '), StdWidgetClass, WCF_PAGE or WCF_CONTAINER );
	

	SkinTabOpen		:= GetSkinItem('TabbookTabOpened');
	SkinTabClose		:= GetSkinItem('TabbookTabClosed');
	SkinTabBackground	:= GetSkinItem('TabbookBackground');
	SkinTabContainer	:= GetSkinItem('TabbookContainer');
    (*
	APPEXPORT(CreateTabBook);
	APPEXPORT(TabBookAddTab);
	APPEXPORT(TabBookDisposeTab);
	APPEXPORT(TabBookRemoveTab);
	APPEXPORT(TabBookSelectTab);
    *)
	(* nur zum Testen < for test only >
	RectAssign(r,100,100,300,300);
	o := CreateTabBook(@Me,r);
	TabBookAddTab(o,'PTAB 1',NIL);
	TabBookAddTab(o,'PTAB 2',NIL);
	TabBookAddTab(o,'PTAB 3',NIL);
	TabBookAddTab(o,'PTAB 4',NIL);
	TabBookAddTab(o,'PTAB 5',NIL);
	TabBookAddTab(o,'PTAB 6',NIL);
	TabBookAddTab(o,'PTAB 7',NIL);
	TabBookAddTab(o,'PTAB 8',NIL);
	InsertWidget(PWIDGET(Desktop),PWIDGET(o));
	WidgetDrawAll(PWIDGET(o));
    *)

	LibMain := true;
end;

procedure Close;
begin

end;

{$ifdef OPascal}
initialization
{$else}
begin
{$endif}
  AppVersion        := ULONG_ID(0,2,0,0);
  SkinTabOpen       := NIL;
  SkinTabClose      := NIL;
  SkinTabBackground := NIL;
  SkinTabContainer  := NIL;

{$endif}  {LINK_CLIBS}
end.
