unit theme;

interface

uses guitypes;

uses guitypes,skin,allegro;

{$i cdefs.inc}

{$ifdef LINK_CLIBS}
  {$link theme.o}
{$endif}

(**
*	Global variables
*)
type
  PTHEMEITEM = ^TTHEMEITEM;
  TTHEMEITEM = record
	Skin	: PImage;
	Left	: l_ulong;
	Right	: l_ulong;
	Top		: l_ulong;
	Bottom	: l_ulong;
  end;


var
  THMPanelFace,
  THMDockFace,
  THMPanelleft,
  THMPanelright,
  THMPanelStart,
  THMPanelStartOver,
  THMPanelStartDown,
  THMPanelCP,
  THMPanelCPOver,
  THMPanelCPDown,
  THMPanelapp,
  THMPanelappOver,
  THMPanelappDown,
  THMPanelUSR,
  THMPanelUSROver,
  THMPanelUSRDown,
  THMPanelQUIT,
  THMPanelQUITOver,
  THMPanelQUITDown,
  THMPanelnav,
  THMPanelnavOver,
  THMPanelnavDown,
  THMSidebarFace,
  THMSidebarClock,
  THMTraybarFace,
  THMPanelTask,
  THMPanelTaskDown,
  THMAlertFace	: PTHEMEITEM;

function ThemeLoadItem ( szThemeFile, Item: l_text ): PTHEMEITEM; {$ifdef LINK_CLIBS}external;{$endif}
procedure ThemeLoad ( szThemeFile: l_text ); {$ifdef LINK_CLIBS}external;{$endif}

implementation
{$ifndef LINK_CLIBS}

procedure DrawLikeSkin(bmp, Skin: p_bitmap; x1,y1,x2,y2, Left,Right,Top,Bottom: integer);
begin
	if not assigned(Skin) then
	begin
		rectfill(out, x1, y1, x2, y2, makecol(0,0,0));
		exit;
	end;

	al_masked_blit(Skin, bmp, 0, 0, x1, y1, Left, Top);
	al_masked_blit(Skin, bmp, 0, Skin^.h-Bottom, x1, y2-Bottom+1, Left, Bottom);
	al_masked_blit(Skin, bmp, Skin^.w-Right, 0, x2-Right+1, y1, Right, Top);
	al_masked_blit(Skin, bmp, Skin^.w-Right, Skin^.h-Bottom, x2-Right+1, y2-Bottom+1, Right, Bottom);

	al_masked_stretch_blit(Skin, bmp, 0, Top, Left, Skin^.h-Top-Bottom, x1, y1+Top, Left, (y2-y1+1)-Top-Bottom);
	al_masked_stretch_blit(Skin, bmp, Skin^.w-Right, Top, Right, Skin^.h-Top-Bottom, x2-Right+1, y1+Top, Right, (y2-y1+1)-Top-Bottom);

	al_masked_stretch_blit(Skin, bmp, Left, 0, Skin^.w-Left-Right, Top, x1+Left, y1, (x2-x1+1)-Left-Right, Top);
	al_masked_stretch_blit(Skin, bmp, Left, Skin^.h-Bottom, Skin^.w-Left-Right, Bottom, x1+Left, y2-Bottom+1, (x2-x1+1)-Left-Right, Bottom);

	al_masked_stretch_blit(Skin, bmp, Left, Top, Skin^.w-Left-Right, Skin^.h-Top-Bottom, x1+Left, y1+Top, (x2-x1)-Left-Right+1, (y2-y1)-Top-Bottom+1);
end;

function ThemeLoadItem ( szThemeFile, Item: l_text ): PTHEMEITEM;
var Filename: l_text; img: PImage; p: PTHEMEITEM;
begin

  Filename := INIGetNew(szThemeFile, Item, 'bmp', '');

  { DebugMessage('IniLoad: textlen [%d]', [Length(Filename)]); }
  
  if (Length(Filename)=0) then ThemeLoadItem := NIL else  { Florian Xaver 15.05.2006: this line fixes a bug if there is no item in the file }
  begin
	Img := LoadImage(Filename);
	if assigned( Img ) then begin
	    NEW(p);
		p^.Skin		:= Img;
		p^.Left		:= INIGetInteger(szThemeFile, Item, 'left', 0);
		p^.Right	:= INIGetInteger(szThemeFile, Item, 'right', 0);
		p^.Top		:= INIGetInteger(szThemeFile, Item, 'top', 0);
		p^.Bottom	:= INIGetInteger(szThemeFile, Item, 'bottom', 0);
		ThemeLoadItem := p;
	end
	else ThemeLoadItem := NIL;
  end;
end;

procedure ThemeLoad ( szThemeFile: l_text );
begin
	{ Sidebar }
	THMSidebarFace	:= ThemeLoadItem(szThemeFile, 'sidebar_face');

	THMSidebarClock	:= ThemeLoadItem(szThemeFile, 'sidebar_clock');

	{ Panel }
	THMDockFace		:= ThemeLoadItem(szThemeFile, 'dock_face');
	THMPanelFace	:= ThemeLoadItem(szThemeFile, 'panel_face');

	THMPanelStart		:= ThemeLoadItem(szThemeFile, 'panel');
	THMPanelStartOver	:= ThemeLoadItem(szThemeFile, 'panel_over');
	THMPanelStartDown	:= ThemeLoadItem(szThemeFile, 'panel_down');

	THMPanelCP		:= ThemeLoadItem(szThemeFile, 'panel');
	THMPanelCPOver	:= ThemeLoadItem(szThemeFile, 'panel_over');
	THMPanelCPDown	:= ThemeLoadItem(szThemeFile, 'panel_down');

	THMPanelapp		:= ThemeLoadItem(szThemeFile, 'panel');
	THMPanelappOver	:= ThemeLoadItem(szThemeFile, 'panel_over');
	THMPanelappDown	:= ThemeLoadItem(szThemeFile, 'panel_down');

	THMPanelUSR		:= ThemeLoadItem(szThemeFile, 'panel');
	THMPanelUSROver	:= ThemeLoadItem(szThemeFile, 'panel_over');
	THMPanelUSRDown	:= ThemeLoadItem(szThemeFile, 'panel_down');

	THMPanelQUIT	:= ThemeLoadItem(szThemeFile, 'panel');
	THMPanelQUITOver	:= ThemeLoadItem(szThemeFile, 'panel_over');
	THMPanelQUITDown	:= ThemeLoadItem(szThemeFile, 'panel_down');

	THMPanelnav	:= ThemeLoadItem(szThemeFile, 'nav');
	THMPanelnavOver	:= ThemeLoadItem(szThemeFile, 'nav_over');
	THMPanelnavDown	:= ThemeLoadItem(szThemeFile, 'nav_down');

	THMPanelleft	:= ThemeLoadItem(szThemeFile, 'panel_left');
	THMPanelright	:= ThemeLoadItem(szThemeFile, 'panel_down');

	THMPanelTask		:= ThemeLoadItem(szThemeFile, 'task');
	THMPanelTaskDown	:= ThemeLoadItem(szThemeFile, 'task_down');

	{ Traybar }
	THMTraybarFace		:= ThemeLoadItem(szThemeFile, 'traybar_face');

	{ Alert }
	THMAlertFace		:= ThemeLoadItem(szThemeFile, 'alert_face');
end;

{$ifdef OPascal}
initialization
{$else}
begin
{$endif}
  THMPanelFace		:= NIL;
  THMDockFace		:= NIL;
  THMPanelleft		:= NIL;
  THMPanelright		:= NIL;
  THMPanelStart		:= NIL;
  THMPanelStartOver	:= NIL;
  THMPanelStartDown	:= NIL;
  THMPanelCP		:= NIL;
  THMPanelCPOver	:= NIL;
  THMPanelCPDown	:= NIL;
  THMPanelapp		:= NIL;
  THMPanelappOver	:= NIL;
  THMPanelappDown	:= NIL;
  THMPanelUSR		:= NIL;
  THMPanelUSROver	:= NIL;
  THMPanelUSRDown	:= NIL;
  THMPanelQUIT		:= NIL;
  THMPanelQUITOver	:= NIL;
  THMPanelQUITDown	:= NIL;
  THMPanelnav		:= NIL;
  THMPanelnavOver	:= NIL;
  THMPanelnavDown	:= NIL;
  THMSidebarFace	:= NIL;
  THMSidebarClock	:= NIL;
  THMTraybarFace	:= NIL;
  THMPanelTask		:= NIL;
  THMPanelTaskDown	:= NIL;
  THMAlertFace	    := NIL;


{$endif}  {LINK_CLIBS}
end.
